/*
 * Client.java - client for shed
 * Copyright (C) 1999-2000 Lubos Balat
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


package sk.jeeff.shed.client;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

import java.net.*;
import java.io.*;

import sk.jeeff.shed.*;
import sk.jeeff.shed.gui.*;

public class Client
{
   int pom1, pom2;

   private boolean IS_CONNECTED=false;

   public static f_main gui;

   static Socket socket = null;
	static Socket dsocket = null;
   PrintWriter ps = null;

   public static Listen listen = null;

   //doba cakania na znova kontrolu dosleho prikazu (v slucke)
   int WAIT_TIME=300;

   //zoznam userov s priradenymi idckami
   Hashtable userList = new Hashtable(25);

   public Client(f_main gui)
   {
      this.gui=gui;
   }

   public int disconnect()
   {
      int ret=0;
      if (socket != null)
	   {
         try
		   {
            listen.suspend();
            ps.println("QUIT");
            ps.flush();
            socket.close();
   			dsocket.close();
            IS_CONNECTED=false;
            ret=1;
         } catch (IOException e)
		   {
            System.out.println("Can't disconnect: " + e);
   		}
         gui.setStatusBar("Disconnected");
      }
   	else gui.setStatusBar("You are not connected to server.");
      return (ret);
   }

	public int connect(String adress)
	{
      int ret=0;
		Integer port=null;
		//if (socket == null) {
		try
      {
		   System.out.println("Connect:");
         gui.setStatusBar("Trying to connect to: " + adress);
         System.out.flush();
			StringTokenizer st = new StringTokenizer(adress, ":");
			adress = st.nextToken();
			if (st.hasMoreTokens()) port = Integer.valueOf(st.nextToken());
			else port = Integer.valueOf("2525");
			socket = new Socket(adress,port.intValue());
			dsocket = new Socket(adress,port.intValue()+1);
			ps = new PrintWriter(socket.getOutputStream());
         ps.println(gui.name_txt.getText());
         ps.println(gui.password_txt.getText());
         ps.flush();
         gui.setStatusBar("Start listen");
         (listen = new Listen(this, gui.name_txt.getText(), socket, dsocket)).start();
			gui.setStatusBar("Connection succesfull");
			//this.send("LISTROJECTS");
         IS_CONNECTED=true;
			ret=1;
      }
      catch (IOException e)
      {
		   disconnect();
			gui.setStatusBar("Can't connect to host. Error: " + e);
      }
		//}
		return(ret);
	}

   public boolean isConnected()
   {
      return(IS_CONNECTED);
   }

   //Sends message to server
   //to=id of client
   //text=message to sent
  	public void send_msg(String to, String text)
	{
	   if (socket != null)
      {
         String msg;
         if (to.compareTo("-1")==0)
         {
            msg="/msg_all#"+text;
         }
         else
         {
            msg="/msg#"+to+"#"+text;
         }
         ps.println(msg);
         ps.flush();
      }
      else gui.setStatusBar("You are not connected...");
	}

   //send message to server
   //text=message to sent
	public void send(String text)
	{
		if (socket != null)
      {
			//StringBuffer msg = new StringBuffer("MSG:");
         ps.println(text);
         ps.flush();
		}
      else gui.setStatusBar("You are not connected...");
	}

   //load project p_name from server
   public void loadProject(String p_name)
   {
      //projectName = new GetProjectNameDialog(textFrame,"Select project",this);
	  	//projectName.show();
	  	//System.out.println(listen.loadProject());
	  	String filelist;
	  	filelist="GETFILE";
	  	for (pom1=0; pom1<gui.l_files.getSize(); pom1++)
	  	{
	  	   filelist=filelist+":projects/"+gui.c_projects.getSelectedItem()+"/"+gui.l_files.getElementAt(pom1);
      }
	  	send(filelist);
	  	//get();
   }

   //depreaced, do not use
   public void getProject()
   {
      send("LISTFILESINPROJECT:" + gui.c_projects.getSelectedItem());
	  	//this.remove(p_project);
	  	//this.add("South",p_files);
	  	//remove(p_server);
	  	//add("Center",p_main);
   }

   //get user list from server
   //returns user list as String array
   public String[] getUsersList()
   {
      Enumeration keys = userList.keys();
      //najskor ich spocitaj
      int count = 0;
      while (keys.hasMoreElements())
      {
         keys.nextElement();
         count ++;
      }
      String ret[] = new String[count];
      keys = userList.keys();
      int i=0;
      while (keys.hasMoreElements())
      {
         ret[i] = (String)userList.get (keys.nextElement());
         i++;
      }
      return (ret);
   }

   public String getUserName(int userId)
   {
      String ret = (String)userList.get(""+userId);
      if (ret==null) ret = "";
      return(ret);
   }

   public int getUserIdFromName(String fullName)
   {
      int ret = -1;
      Enumeration keys = userList.keys();
      String key;
      System.out.print("Searching for: "+fullName);
      while (keys.hasMoreElements())
      {
         key = (String)keys.nextElement();
         System.out.print(" key="+key+" val="+userList.get(key));
         if (userList.get(key).equals(fullName))
         {
            ret = Integer.parseInt(key);
            break;
         }
      }
      System.out.println(" found="+ret);
      return(ret);
   }

   public synchronized void getUserList()
   {
      gui.setStatusBar("Getting user list.");
      System.out.println("----------------------");
      listen.user_list="";
      send("/get_user_list");
      System.out.println("CAKAM");
      while (listen.user_list.length()<1)
      {
        try
        {
            Thread.sleep(WAIT_TIME);
            System.out.print(".");
            gui.paint(gui.getGraphics());
        } catch (InterruptedException e)
        {
        }
      }
      System.out.println("POKRACUJEM");
      StringTokenizer st = new StringTokenizer(listen.user_list, "#");
      int count=st.countTokens();
      int i;
      String id;
      String name;
      for (i=0; i<count; i++)
      {
         name=st.nextToken();
         //je to cislo, ale ma to byt object, takze moze byt String
         id = st.nextToken();
         i++;
         userList.put(id, name);
      }
      listen.user_list="";
      gui.setStatusBar("User list complete.");
   }

   //get file from server
   //return 1 if file is downloaded
   //return 0 if file is locked on server
   public synchronized int getFile(String filename)
   {
      System.out.println("----------------------");
      listen.ret_get_file=-1;
      send("/get_file#"+filename);
      System.out.println("CAKAM");
      while (listen.ret_get_file==-1)
      {
        try
        {
            Thread.sleep(WAIT_TIME);
            //System.out.println("ZOBUDENY!!!!!! ret="+listen.ret_get_file);
        } catch (InterruptedException e)
        {
        }
      }
      System.out.println("POKRACUJEM");

      return(listen.ret_get_file);
   }

   //get element elementName in file filename from server
   //return -1 if element is not downloaded
   public synchronized int getElement(String filename, String elementName)
   {
      System.out.println("------- Getting element ------");
      listen.ret_get_file=-1;
      send("/get_element#"+filename+"#"+elementName);
      System.out.println("CAKAM");
      waitForEnd(Listen.RET_GET_ELEMENT);
      System.out.println("POKRACUJEM");

      return(listen.ret_get_file);
   }

   //put element elementName in file filename to server
   public synchronized int putElement(String filename, String elementName)
   {
      System.out.println("------- Putting element ------");

      return(listen.putElement(filename, elementName));
   }

   //wait for reply from server
   public synchronized int waitForEnd(int index)
   {
      System.out.println("WAITING FOR: "+index);
      int ret;
      while (listen.retWait[index]==0)
      {
        try
        {
            Thread.sleep(WAIT_TIME);
            //System.out.println("ZOBUDENY!!!!!! ret="+listen.ret_get_file);
            System.out.print(".");
            gui.paint(gui.getGraphics());
        } catch (InterruptedException e)
        {
        }
        System.out.println("WAITING FOR: "+index);
      }

      ret=listen.retWait[index];
      listen.retWait[index]=0;

      return(ret);
   }

   //alloc file filename in server
   public synchronized int allocElement(String fileName, String elementName)
   {
      listen.retWait[Listen.RET_ALLOC_ELEMENT]=0;
      send("/alloc_element#"+fileName+"#"+elementName);
      return(waitForEnd(Listen.RET_ALLOC_ELEMENT));
   }

   //unalloc file filename in server
   public synchronized int unAllocElement(String fileName, String elementName)
   {
      listen.retWait[Listen.RET_UNALLOC_ELEMENT]=0;
      send("/unalloc_element#"+fileName+"#"+elementName);
      return(waitForEnd(Listen.RET_UNALLOC_ELEMENT));
   }

   //put file origFileName to server
   public synchronized int putFile(String origFileName)
   {
      return (listen.putFileAs(origFileName, origFileName));
   }

   //put file origFileName to server as newFileName
   public synchronized int putFileAs(String origFileName, String newFileName)
   {
      return (listen.putFileAs(origFileName, newFileName));
   }

   //create new file on server
   public synchronized int createNewFile(String filename)
   {
      send("/new_file#"+filename);
      int ret=waitForEnd(Listen.RET_NEW_FILE);
      if (ret==-1)  JOptionPane.showMessageDialog(gui, "Can't create file on server.", "Error", JOptionPane.ERROR_MESSAGE);
      return (ret);
   }

   //create new element elementName after element afterElementName in file filename on server
   public synchronized int createNewElement(String filename, String elementname, String afterElementName)
   {
      send("/new_element#"+filename+"#"+elementname+"#"+afterElementName);
      int ret=waitForEnd(Listen.RET_NEW_ELEMENT);
      return(ret);
   }

   //update elementnames on server in file filename
   //elementnames=element names in one string apart using # sign (eg: #element1#element2#element3)
   public synchronized int updateElements(String filename, String elementnames)
   {
            //elementnames allready contains char #
      send("/update_element_names#"+filename+elementnames);
      int ret=waitForEnd(Listen.RET_UPDATE_ELEMENT_NAMES);
      return(ret);
   }

   public synchronized int createProject(String projectName, String projectLeader, String[] projectMembers)
   {
      String users = ""+getUserIdFromName(projectLeader);
      int i;
      for (i=0; i<projectMembers.length; i++)
      {
         System.out.println("user="+projectMembers[i]+" users="+users);
         users = users + "#" + getUserIdFromName(projectMembers[i]);
      }
      send("/new_project#"+projectName+"#"+users);
      int ret=waitForEnd(Listen.RET_NEW_PROJECT);
      return(ret);
   }

}
