/*
 * Listen.java - listen thread for client
 * Copyright (C) 1999-2000 Lubos Balat
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package sk.jeeff.shed.client;

import java.applet.*;

import java.awt.*;
import java.net.*;
import java.io.*;
import java.util.*;

import sk.jeeff.shed.project.*;
import sk.jeeff.shed.parser.*;
import sk.jeeff.shed.gui.*;
import sk.jeeff.shed.*;

public class Listen extends Thread
{
   String name = null;
   DataInputStream dis = null;
   BufferedReader br = null;
   BufferedInputStream bis = null;
   BufferedOutputStream bos = null;

   InputStream is = null;
   //socket for commands
   Socket socket = null;
   //socket for data
   Socket dsocket = null;
   Client client = null;

   String text;

   int pom1,pom2;

   int DEBUG=1;
   private int BUFFSIZE=sk.jeeff.shed.server.Client.BUFFSIZE;

   //Stringy pre navratove hodnoty
   public String user_list="";
   public int ret_get_file=-1;

   private int retCount=100;
   public int[] retWait=new int[retCount];

   //return variables for waiting for reply from server
   public static final int RET_NEW_FILE=1;
   public static final int RET_NEW_ELEMENT=2;
   public static final int RET_GET_ELEMENT=3;
   public static final int RET_PUT_ELEMENT=4;
   public static final int RET_ALLOC_ELEMENT=5;
   public static final int RET_UNALLOC_ELEMENT=6;
   public static final int RET_UPDATE_ELEMENT_NAMES=7;
   public static final int RET_FILE_LIST=8;
   public static final int RET_NEW_PROJECT=9;

   //Path Separator char
   char PathSep = File.separatorChar;

   //ProjectInfo
   ProjectInfo project;

   //constructor
   //n=user name (nick)
   //s=socket for command
   //ds=socket for data
   public Listen(Client client, String n, Socket s, Socket ds)
   {
      this.client = client;
      name = n;
      socket = s;
      dsocket = ds;
      int i;

      for (i=0; i<retCount; i++) retWait[i]=0;

      try
      {
         is = s.getInputStream();
         dis = new DataInputStream(is);
         br = new BufferedReader(new InputStreamReader(is),BUFFSIZE);
         bis = new BufferedInputStream(ds.getInputStream(),BUFFSIZE);
         bos=new BufferedOutputStream(ds.getOutputStream(),BUFFSIZE);
         //ps = new PrintWriter(s.getOutputStream());
      } catch (IOException e)
      {
         System.out.println("Error: " + e);
         client.disconnect();
      }
   }

   //main loop, read commands from stream
   public void run ()
   {
      String msg = null;
      String keyword;
      String tmpString;
      while (true)
      {
         try
         {
            msg = br.readLine();
         } catch (IOException e)
         {
            System.out.println("Error: " + e);
            client.disconnect();
         }
         //client is disconnected
         if (msg == null)
         {
            Client.listen = null;
            Client.socket = null;
            Client.gui.l_user_list.clear();
            return;
         }
         System.out.println("Message: " + msg);
         StringTokenizer st = new StringTokenizer(msg, "#");

         //get keyword
         if (st.hasMoreTokens()) keyword = st.nextToken();
         else keyword="";

         //System.out.println("Keyword:" + keyword);
         if (keyword.equals("/user_list")) kwUserList(st.nextToken("\0"));
         else if (keyword.equals("/RET:file_locked")) ret_get_file=0;
         else if (keyword.equals("/your_full_name"))
         {
            String fullName = st.nextToken();
            System.out.println("FULL NAME="+fullName);
            client.gui.setMyFullName(fullName);
         }
         else if (keyword.equals("/people"))
         {
            Client.gui.l_user_list.clear();
            Client.gui.user_id_list=new String[st.countTokens()];
            int count=0;
            int pos;
            while (st.hasMoreTokens())
            {
               String str = st.nextToken();
               try
               {
                  pos=str.indexOf('-');
                  Client.gui.l_user_list.addElement(str.substring(pos+1));
                  Client.gui.user_id_list[count]=str.substring(0,pos);
                  //System.out.println(name + " Adding:"+ str+ " Pos="+pos+" ID="+Client.gui.user_id_list[count]);
                  count++;
               }
               catch (Exception e)
               {
                  Client.gui.setStatusBar("Error: Wrong user list...");
               }
            }
         }
         else if (keyword.equals("/msg"))
         {
            //String usr = st.nextToken();
            //Client.gui.chat_board.append(usr);
            //Client.gui.chat_board.append(st.nextToken("\0") + "\n");
            Client.gui.chatBoardAdd(st.nextToken(), st.nextToken("\0").substring(1));
         }
         else if (keyword.equals("/fopen"))
         {
            kwFopen(st);
         }
         else if (keyword.equals("/put_element"))
         {
            kwPutElement(st);
         }
         else if (keyword.equals("/new_file"))
         {
            kwNewFile(st);
         }
         else if (keyword.equals("/RET:new_file"))
         {
            kwRetNewFile(st);
         }
         else if (keyword.equals("/new_element"))
         {
            kwNewElement(st);
         }
         else if (keyword.equals("/RET:update_element_names"))
         {
            tmpString=st.nextToken();
            if (tmpString.equals("OK")) retWait[RET_UPDATE_ELEMENT_NAMES]=1;
            else retWait[RET_UPDATE_ELEMENT_NAMES]=-1;
         }
         else if (keyword.equals("/RET:alloc_element"))
         {
            tmpString=st.nextToken();
            if (tmpString.equals("OK")) retWait[RET_ALLOC_ELEMENT]=1;
            else retWait[RET_ALLOC_ELEMENT]=-1;
         }
         else if (keyword.equals("/RET:unalloc_element"))
         {
            tmpString=st.nextToken();
            if (tmpString.equals("OK")) retWait[RET_UNALLOC_ELEMENT]=1;
            else retWait[RET_UNALLOC_ELEMENT]=-1;
         }
         else if (keyword.equals("/RET:listprojects"))
         {
            //Client.gui.c_projects.removeAll();
            //Client.
            while (st.hasMoreTokens())
            {
                 Client.gui.c_projects.addElement(st.nextToken());
            }
         }
         else if (keyword.equals("/RET:new_project"))
         {
            System.out.println("-----------------------------------------------");
            if (st.nextToken().equals("OK")) retWait[RET_NEW_PROJECT]=1;
            else retWait[RET_NEW_PROJECT]=-1;
         }
         else if (keyword.equals("FILESINPROJECT"))
         {
            Client.gui.l_files.clear();
            //Client.
            pom2=st.countTokens();
            for (pom1=0; pom1<pom2; pom1++)
            {
               Client.gui.l_files.addElement(st.nextToken());
            }
         }
         else if (keyword.equals("/quit"))
         {
            if (st.hasMoreTokens())
            {
               Client.gui.setStatusBar(st.nextToken("\0"));
            }
            //client.gui.disconnect();
            return;
         }
         else if (keyword.equals("/file_list"))
         {
            kwFileList(st);
         }
         else if (keyword.equals("/clear_files_in_project"))
         {
            client.gui.clearProjectFiles(st.nextToken());
         }
         else if (keyword.equals("/RET:file_list_ok"))
         {
            //TODO: osetrit zle poslatie
            retWait[RET_FILE_LIST] = 1;
         }
      }
   }

   //server sends element to client
   public int kwPutElement(StringTokenizer st)
   {
      String directory="";
      String filename=st.nextToken();
      String elementName = st.nextToken();
      String fileSize=st.nextToken();
      StringBuffer outString=new StringBuffer("DATA:");

         //System.out.println("Server Put java element");

         //System.out.println("CREATING ABSOLUTE PATH");
         String ret[]=createAbsolutePath(filename);
         filename=ret[0];
         directory=ret[1];

         ElementParser parser = new ElementParser();
         parser.readFile(directory + PathSep + filename);

         try
         {
            FileOutputStream os = new FileOutputStream(directory + PathSep + filename);
            DataOutputStream dos = new DataOutputStream(os);

            //parser.writeFile(dos);
            parser.writeBeforeElement(dos, elementName);

            parser.writeHeaderBegin(dos, elementName, "unknown");

            int readed=readFromDataStream(filename, directory, fileSize, dos);

            //parser.writeHeaderEnd(dos, false);

            parser.writeAfterElement(dos);

            dos.flush();
            os.flush();
            dos.close();
            os.close();
            dbg("File closed");

            retWait[RET_GET_ELEMENT]=1;

         } catch (Exception ex)
         {
            client.gui.setStatusBar("Error: Can't write to file "+filename);
            retWait[RET_GET_ELEMENT]=0;
         }
      return(1);
   }

   //server sends user list
   public void kwUserList(String msg)
   {
      user_list=msg;
   }

   public void kwFileList(StringTokenizer st)
   {
      try
      {
         String path=st.nextToken();
         String file=st.nextToken();
         int file_type=Integer.parseInt(st.nextToken());
         int file_created_by=Integer.parseInt(st.nextToken());
         long file_created_date=Long.parseLong(st.nextToken())*1000;
         String elementName=st.nextToken();
         int locked_by=Integer.parseInt(st.nextToken());
         long locked_date=Long.parseLong(st.nextToken())*1000;
         int element_created_by=Integer.parseInt(st.nextToken());
         //int element_created_date=Integer.parseInt(st.nextToken());

         //zostroj FileInfo
         FileInfo finfo = new FileInfo(path+"/"+file, FileInfo.SUB_FILE, FileInfo.ALLOCATED_FREE);
         finfo.setOwner(client.getUserName(locked_by));
         finfo.setElementName(elementName);
         finfo.setCreator(client.getUserName(file_created_by));
         finfo.setCreateDate(file_created_date);
         finfo.setLockedDate(locked_date);
         client.gui.getFilesTree().addToTree(finfo);
      }
      catch (Exception ex)
      {
         System.out.println("CHYBA file list:"+ex.getMessage());
      }

   }

   //create new file
   public void kwNewFile(StringTokenizer st)
   {
      String origFilename=st.nextToken();
      String filename= createAbsolutePathToFile(origFilename);
      try
      {
         File f = new File(filename);
         f.createNewFile();
         //f.canWrite();
         //f.setReadOnly();

         retWait[RET_NEW_FILE]=1;
      }
      catch (Exception ex)
      {
         System.out.println("Can't create file: "+filename);
         //TODO: send error to client
      }

   }

   //server reply for command newFile
   public void kwRetNewFile(StringTokenizer st)
   {
      String msg=st.nextToken();
      if (msg.equals("OK")) retWait[RET_NEW_FILE]=1;
      else retWait[RET_NEW_FILE]=-1;
   }

   //server sends new element
   public void kwNewElement(StringTokenizer st)
   {
      String origFilename=st.nextToken();
      String elementName = st.nextToken();
      String afterElementName="";
      if (st.hasMoreTokens()) afterElementName = st.nextToken();

      String filename, directory;
      //parse existing file and create new element in it
      if (origFilename.toLowerCase().endsWith(".java"))
      {
         System.out.println("Server Put new java element: "+elementName+" after: "+afterElementName);

         System.out.println("CREATING ABSOLUTE PATH");
         String ret[]=createAbsolutePath(origFilename);
         filename=ret[0];
         directory=ret[1];

         ElementParser parser = new ElementParser();
         parser.readFile(directory + PathSep + filename);

         parser.createNewElementAfter(afterElementName, elementName, "unknown");

         retWait[RET_NEW_ELEMENT]=1;
      }

   }

   //create absolute path to file origFileName using directory with current project
   public String createAbsolutePathToFile(String origFileName)
   {
      String ret[];
      ret=createAbsolutePath(origFileName);
      return (ret[1]+PathSep+ret[0]);
   }

   //returns absolute path to file origFileName
   //ret[0]=filename
   //ret[1]=directory
   public String[] createAbsolutePath(String origFileName)
   {
      String filename, directory;
      String ret[]=new String[2];
      StringTokenizer sd = new StringTokenizer(origFileName, "/");


      project=client.gui.getProjectInfo();

      System.out.println("Project main dir:"+project.getLocalPath());

      directory=ShedTools.convertPathSeparatorToSystem(project.getLocalPath());
      pom2=sd.countTokens();

      for (pom1=1; pom1<=pom2-1; pom1++)
      {
         directory = directory + PathSep + sd.nextToken();
      }

      //directory = directory + sd.nextToken();

      filename=sd.nextToken();

      ret[0]=filename;
      ret[1]=directory;

      return(ret);
   }

   //server sends file
   public void kwFopen(StringTokenizer st)
   {
      String filename="";
      String directory="";
      String fileSize;

      System.out.println("CREATING ABSOLUTE PATH");
      String ret[]=createAbsolutePath(st.nextToken());
      filename=ret[0];
      directory=ret[1];
      fileSize=st.nextToken();

      dbg("FOPEN: filename="+filename+" directory="+directory+" filesize="+fileSize);

      //output stream to write file
      try
      {

         //first try to create directory...
         File f=new File(directory);
         f.mkdirs();

         dbg("Pred fileOutStream path="+directory + PathSep + filename);

         FileOutputStream os = new FileOutputStream(directory + PathSep + filename);
         DataOutputStream dos = new DataOutputStream(os);

         int readed;

         dbg("pred readed");

         readed=readFromDataStream(filename, directory, fileSize, dos);

         dbg("po readed");

         dos.flush();
         os.flush();
         dos.close();
         os.close();
         dbg("File closed");
      } catch (Exception ex)
      {
         client.gui.setStatusBar("Error: Can't write to file "+filename);
         dbg("Can't write to file "+filename);
      }

      // client.notifyAll();
      //Client.chat_txt.appendText(st.nextToken("\0") + "\n");
      ret_get_file=1;
   }

   //read from data stream
   //filename=filename to which will be data sent
   //directory=directory where file is
   //dos=data stream to which will be data from server written
   private int readFromDataStream(String filename, String directory, String fileSize, DataOutputStream dos)
   {
      byte buff[] = new byte[BUFFSIZE+10];

      int lsb, msb;
      //byte size[]=new byte[2];
      long fileLengthCount;

      try
      {
         System.out.println("Writing file="+filename+" to dir="+directory);

         File dir = new File(directory);
         //File file = new File(directory + filename);
         System.out.println("Creating dir: " + dir.mkdirs());


         dbg("dos=" + dos.toString());
         int count;
         dbg("COUNT");

         fileLengthCount=0;

         msb=bis.read()-5;
         lsb=bis.read();
         count=msb*256+lsb;
         System.out.println("msb="+msb+" lsb=" + lsb + " total=" + ((msb*256)+lsb) + " count="+count);
         while (count !=0)
         {
            int value;
            for (int pom1=0;pom1<count;pom1++)
            {
               value=bis.read();
               if (value==-1) System.out.println("---VALUE="+value);
               buff[pom1]=(byte)value;
            }
            dbg("Writing " + count + " bytes");

            dos.write(buff,0,count);

            fileLengthCount+=count;

            //client.ps.println("GETFILE OK");
            //client.ps.flush();
            bos.write(0);
            bos.flush();

            client.gui.setStatusBar("Downloading "+filename+" "+fileLengthCount+"/"+fileSize);

            msb=bis.read()-5;
            lsb=bis.read();
            count=msb*256+lsb;
            System.out.println("msb="+msb+" lsb=" + lsb + " total=" + ((msb*256)+lsb) + " count="+count);
         }
         dbg("Writing ended");

         //client.ps.println("GETFILE OK");
         //client.ps.flush();
         bos.write(0);
         bos.flush();

         client.gui.setStatusBar("Download successfull");

      } catch (IOException ex)
      {
         System.out.println("Can't open file for write...");
         return(0);
      }
      return(1);
   }

   //send file origFileName to server as file newFileName
   public int putFileAs(String origFileName, String newFileName)
   {
      try
      {
         String str_line;
         String filename;
         File file;
         int line_number;

         filename=createAbsolutePathToFile(origFileName);
         file = new File(filename);

         System.out.println("filename="+filename+" PATH="+file.getAbsolutePath());

         FileInputStream is = new FileInputStream(filename);
         DataInputStream ds = new DataInputStream(is);

         client.send("/fopen#"+newFileName+"#"+file.length());
         dbg("File opened: " + origFileName);

         //TODO: osetrit nespravny zapis
         writeToStream(ds);

         dbg("Closing ds");
         ds.close();
         is.close();

      } catch (IOException e)
      {
         System.out.println("Can't read file..." + e);
      }
      return(1);
   }

   //write data to server from stream ds
   private int writeToStream(DataInputStream ds)
   {
      int count;
      //lsb & msb byte of size
      int lsb,msb;
      //byte size[]=new byte[2];

      byte buff[] = new byte[sk.jeeff.shed.server.Client.BUFFSIZE-10];

      try
      {
            while ((count = ds.read(buff)) != -1)
            {
               System.out.println("count="+count);
               msb= (count/256);
               lsb= (count - (msb*256));
               System.out.println("msb="+msb+" lsb="+lsb);


               dbg("Sending " + count + " bytes");

               bos.write(msb+5);
               bos.write(lsb);

               bos.write(buff,0,count);
               bos.flush();

               //wait for client OK
               dbg("Waiting:");
               dbg(""+bis.read());
            }
            dbg("Writing 0");
            //msb
            bos.write(0+5);
            //lsb
            bos.write(0);
            bos.flush();

            //wait for client OK
            dbg("Waiting:");
            dbg(""+bis.read());

         return (1);
      }
      catch (IOException ioex)
      {
         dbg("Can't write to server data stream"+ioex.getMessage());
         return(0);
      }
   }

   //send element elementName in file origFileName to server
   public int putElement(String origFilename, String elementName)
   {

      //parser.getElementLines(elementName);
      String path;

      try
      {
         String filename=createAbsolutePathToFile(origFilename);
         ElementParser parser = new ElementParser();
         parser.readFile(filename);

         File f=File.createTempFile("shed.tmp.","");
         path=f.getAbsolutePath();
         System.out.println("CREATING temp file path="+path);

         parser.writeElementLines(path, elementName);

         FileInputStream is = new FileInputStream(path);
         DataInputStream ds = new DataInputStream(is);

         File f2=new File(path);

         client.send("/put_element#"+origFilename+"#"+elementName+"#"+f2.length());

         //TODO: osetrit nespravny zapis
         writeToStream(ds);

         dbg("Closing ds");
         ds.close();
         is.close();
      }
      catch (Exception ex)
      {
         System.out.println("Can't create tmp file for element:"+elementName);
         return(0);
      }
      return(1);
   }

   //write error message
   public void err(String text)
    {
      System.err.println(text);
    }

    //write debug message
    public void dbg(String text)
    {
      if (DEBUG==1) System.out.println(text);
    }

}

