/*
 * FileInfoPropertiesDialog.java - open new window with FileInfo properties
 * Copyright (C) 1999-2000 Lubos Balat
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package  sk.jeeff.shed.gui;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;
import javax.swing.JFileChooser;
import javax.swing.JList;
import java.io.*;
import java.beans.*;
import com.borland.jbcl.layout.*;

public class FileInfoPropertiesDialog extends JDialog {
  JPanel panel1 = new JPanel();
  JPanel panel2 = new JPanel();
  JPanel jPanel1 = new JPanel();
   BorderLayout borderLayout1 = new BorderLayout();

  private boolean OK=false;
   JLabel statusBar = new JLabel();
   JButton b_OK = new JButton();
   JButton b_CANCEL = new JButton();
   JLabel jLabel1 = new JLabel();
   JComboBox cb_NodeType = new JComboBox();
   JLabel jLabel2 = new JLabel();
   JTextField t_FileName = new JTextField();
   JButton b_FileNameBrowse = new JButton();
   JLabel jLabel3 = new JLabel();
   JTextField t_ElementName = new JTextField();

   String currentProjectLocalPath="";

   //selected path in FilesTree
   private String selectedPath="";

   //types in popup menu
   String types[];

  public FileInfoPropertiesDialog(f_main frame, String title, boolean modal)
  {
    super(frame, title, modal);
    this.setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
    OK=false;
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }


    types=FileInfo.getTypeNames();
    for (int i=0; i<types.length; i++) cb_NodeType.addItem(types[i]);

    currentProjectLocalPath=frame.getProjectInfo().getLocalPath().toLowerCase();
    selectedPath= currentProjectLocalPath + File.separatorChar + frame.getFilesTree().getSelectedFileInfo().getFilePath();

    pack();
  }

  public FileInfoPropertiesDialog(f_main frame, String title)
  {
    this(frame, title, false);
  }

  public FileInfoPropertiesDialog(f_main frame)
  {
    this(frame, "", false);
  }

  private void jbInit() throws Exception
  {
    jPanel1.setLayout(null);
      panel2.setBorder(BorderFactory.createRaisedBevelBorder());
      panel2.setMaximumSize(new Dimension(530, 150));
      panel2.setPreferredSize(new Dimension(530, 150));
      panel2.setLayout(null);
    panel1.setLayout(borderLayout1);
      panel1.setPreferredSize(new Dimension(530, 250));
      jPanel1.setMinimumSize(new Dimension(1, 40));
      jPanel1.setPreferredSize(new Dimension(1, 40));
      statusBar.setForeground(Color.red);
      statusBar.setBounds(new Rectangle(9, 9, 311, 24));

      b_OK.setText("OK");
      b_OK.setBounds(new Rectangle(316, 7, 89, 27));
      b_OK.addActionListener(new FileInfoPropertiesDialog_b_OK_actionAdapter(this));
      b_CANCEL.setText("Cancel");
      b_CANCEL.setBounds(new Rectangle(419, 7, 80, 27));
      b_CANCEL.addActionListener(new FileInfoPropertiesDialog_b_CANCEL_actionAdapter(this));
      jLabel1.setText("Node type:");
      jLabel1.setBounds(new Rectangle(25, 27, 84, 21));
      cb_NodeType.setBounds(new Rectangle(112, 27, 197, 21));
      cb_NodeType.addActionListener(new java.awt.event.ActionListener()
      {

         public void actionPerformed(ActionEvent e)
         {
            cb_NodeType_actionPerformed(e);
         }
      });
      jLabel2.setText("File Name:");
      jLabel2.setBounds(new Rectangle(23, 64, 162, 20));
      t_FileName.setEditable(false);
      t_FileName.setText("");
      t_FileName.setBounds(new Rectangle(23, 86, 375, 21));
      b_FileNameBrowse.setText("Browse");
      b_FileNameBrowse.setBounds(new Rectangle(413, 85, 86, 23));
      b_FileNameBrowse.addActionListener(new FileInfoPropertiesDialog_b_FileNameBrowse_actionAdapter(this));
      jLabel3.setToolTipText("");
      jLabel3.setText("Element Name");
      jLabel3.setBounds(new Rectangle(24, 131, 209, 20));
      t_ElementName.setText("");
      t_ElementName.setBounds(new Rectangle(23, 152, 312, 22));
      panel1.add(jPanel1, BorderLayout.SOUTH);
      jPanel1.add(statusBar, null);
      jPanel1.add(b_OK, null);
      jPanel1.add(b_CANCEL, null);
      panel1.add(panel2, BorderLayout.CENTER);
      panel2.add(jLabel1, null);
      panel2.add(cb_NodeType, null);
      panel2.add(jLabel2, null);
      panel2.add(t_FileName, null);
      panel2.add(b_FileNameBrowse, null);
      panel2.add(jLabel3, null);
      panel2.add(t_ElementName, null);
    getContentPane().add(panel1);
   }

   //if user click OK true
   public boolean getOK()
   {
      return(OK);
   }

   public void setElementName(String name)
   {
      t_ElementName.setText(name);
   }
   public String getElementName()
   {
      return (t_ElementName.getText());
   }

   public void setFileName(String fileName)
   {
      t_FileName.setText(fileName);
   }
   public String getFileName()
   {
      return(t_FileName.getText());
   }

   public void setType(int type)
   {
      cb_NodeType.setSelectedIndex(type);
      cb_NodeType.setSelectedItem(types[type]);
   }
   public int getType()
   {
      return (cb_NodeType.getSelectedIndex());
   }

   void b_OK_actionPerformed(ActionEvent e)
   {
      this.setVisible(false);
      OK=true;
   }

   void b_CANCEL_actionPerformed(ActionEvent e)
   {
      this.setVisible(false);
   }

   void b_FileNameBrowse_actionPerformed(ActionEvent e)
   {
      String filename;
      ShedFileChooser fc = new ShedFileChooser();

      fc.setProjectRoot(currentProjectLocalPath);
      ProjectDirFilter filter=new ProjectDirFilter(currentProjectLocalPath);
      fc.setMultiSelectionEnabled(false);
      fc.setFileFilter(filter);
      if (this.getType()==FileInfo.DIR) fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
      else fc.setFileSelectionMode(JFileChooser.FILES_ONLY);

      fc.setCurrentDirectory(new File(selectedPath));
      int returnVal = fc.showOpenDialog(this);

      if (returnVal == JFileChooser.APPROVE_OPTION)
      {
        System.out.println("Getting file");
        try
        {
           //filename=fc.getSelectedFile().getCanonicalPath();
           filename=fc.getFile();
           //if (filename.toLowerCase().startsWith(currentProjectLocalPath)) t_FileName.setText(filename.substring(currentProjectLocalPath.length()));
           if (filename.length()>0) t_FileName.setText(filename);
           else JOptionPane.showMessageDialog(this, "You can't add file outside the project root directory.", "Error", JOptionPane.ERROR_MESSAGE);
        } catch (Exception ex)
        {
            System.out.println("Bad file location...");
        }
      }
   }

   //show and hide some components depend on current type
   void cb_NodeType_actionPerformed(ActionEvent e)
   {
      if (cb_NodeType.getSelectedIndex()== FileInfo.SUB_FILE)
      {
         t_ElementName.setVisible(true);
         jLabel3.setVisible(true);
         b_FileNameBrowse.setVisible(false);
      }
      else
      {
         t_ElementName.setVisible(false);
         jLabel3.setVisible(false);
         b_FileNameBrowse.setVisible(true);
      }

   }

}

class FileInfoPropertiesDialog_b_OK_actionAdapter implements java.awt.event.ActionListener
{
   FileInfoPropertiesDialog adaptee;

   FileInfoPropertiesDialog_b_OK_actionAdapter(FileInfoPropertiesDialog adaptee)
   {
      this.adaptee = adaptee;
   }

   public void actionPerformed(ActionEvent e)
   {
      adaptee.b_OK_actionPerformed(e);
   }
}

class FileInfoPropertiesDialog_b_CANCEL_actionAdapter implements java.awt.event.ActionListener
{
   FileInfoPropertiesDialog adaptee;

   FileInfoPropertiesDialog_b_CANCEL_actionAdapter(FileInfoPropertiesDialog adaptee)
   {
      this.adaptee = adaptee;
   }

   public void actionPerformed(ActionEvent e)
   {
      adaptee.b_CANCEL_actionPerformed(e);
   }
}

class FileInfoPropertiesDialog_b_FileNameBrowse_actionAdapter implements java.awt.event.ActionListener
{
   FileInfoPropertiesDialog adaptee;

   FileInfoPropertiesDialog_b_FileNameBrowse_actionAdapter(FileInfoPropertiesDialog adaptee)
   {
      this.adaptee = adaptee;
   }

   public void actionPerformed(ActionEvent e)
   {
      adaptee.b_FileNameBrowse_actionPerformed(e);
   }
}





