/*
 * NewProjectWizard.java - open new window with project properties
 * Copyright (C) 1999-2000 Lubos Balat
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


package  sk.jeeff.shed.gui;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;
import javax.swing.JFileChooser;
import javax.swing.JList;
import java.io.*;
import java.beans.*;

public class NewProjectWizard extends JDialog {
  JPanel panel1 = new JPanel();
  JPanel panel2 = new JPanel();
  Border border1;
  JPanel jPanel1 = new JPanel();
   JTextField local_path = new JTextField();
   JLabel jLabel1 = new JLabel();
   JButton local_path_browse = new JButton();
   JLabel jLabel2 = new JLabel();
   BorderLayout borderLayout1 = new BorderLayout();
   JButton b_OK = new JButton();
   JButton b_CANCEL = new JButton();
   public DefaultListModel l_project_members_list = new DefaultListModel();

  private boolean OK=false;
   JLabel jLabel3 = new JLabel();
   JList l_project_members = new JList(l_project_members_list);
   JLabel jLabel4 = new JLabel();
   JLabel statusBar = new JLabel();
   JTextField project_name = new JTextField();
   JScrollPane jScrollPane1 = new JScrollPane();
   JComboBox cb_project_leader = new JComboBox();
   JLabel jLabel5 = new JLabel();
   JLabel local_owner = new JLabel();

  public NewProjectWizard(f_main frame, String title, boolean modal)
  {
    super(frame, title, modal);
    this.setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
    OK=false;
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }

    String users[]=frame.client.getUsersList();
    for (int i=0; i<users.length; i++)
    {
       l_project_members_list.addElement(users[i]);
       cb_project_leader.addItem(users[i]);
    }
    cb_project_leader.setSelectedIndex(-1);

    pack();
  }

  public NewProjectWizard(f_main frame, String title)
  {
    this(frame, title, false);
  }

  public NewProjectWizard(f_main frame)
  {
    this(frame, "", false);
  }

  private void jbInit() throws Exception
  {
    border1 = BorderFactory.createRaisedBevelBorder();
    jPanel1.setLayout(null);
    panel2.setBorder(border1);
      panel2.setPreferredSize(new Dimension(200, 150));
      panel2.setLayout(null);
    panel1.setLayout(borderLayout1);
      local_path.setBounds(new Rectangle(21, 120, 341, 22));
      jLabel1.setText("Local path:");
      jLabel1.setBounds(new Rectangle(21, 98, 320, 20));
      local_path_browse.setText("Browse");
      local_path_browse.setBounds(new Rectangle(379, 120, 106, 23));
      local_path_browse.addActionListener(new NewProjectWizard_local_path_browse_actionAdapter(this));
    jLabel2.setText("Project name:");
      jLabel2.setBounds(new Rectangle(20, 26, 216, 23));
      panel1.setPreferredSize(new Dimension(520, 500));
      jPanel1.setMinimumSize(new Dimension(1, 40));
      jPanel1.setPreferredSize(new Dimension(1, 40));
      b_OK.setText("OK");
      b_OK.setBounds(new Rectangle(326, 8, 86, 26));
      b_OK.addActionListener(new NewProjectWizard_b_OK_actionAdapter(this));
      b_CANCEL.setText("Cancel");
      b_CANCEL.setBounds(new Rectangle(425, 8, 78, 27));
      b_CANCEL.addActionListener(new NewProjectWizard_b_CANCEL_actionAdapter(this));
      jLabel3.setText("Project Leader:");
      jLabel3.setBounds(new Rectangle(23, 167, 146, 21));
      jLabel4.setText("Project Members:");
      jLabel4.setBounds(new Rectangle(269, 166, 190, 19));
      statusBar.setForeground(Color.red);
      statusBar.setBounds(new Rectangle(9, 9, 311, 24));
      project_name.setBounds(new Rectangle(20, 45, 339, 23));
      jScrollPane1.setBounds(new Rectangle(268, 184, 224, 153));
      cb_project_leader.setAutoscrolls(true);
      cb_project_leader.setMaximumRowCount(10);
      cb_project_leader.setBounds(new Rectangle(21, 188, 212, 24));
      cb_project_leader.addActionListener(new ActionListener()
      {
         public void actionPerformed(ActionEvent e)
         {
            if (cb_project_leader.getSelectedIndex()!=-1)
            {
               l_project_members.setSelectedIndex(cb_project_leader.getSelectedIndex());

            }
         }
      });

      l_project_members.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
      jLabel5.setText("Local owner:");
      jLabel5.setBounds(new Rectangle(22, 262, 216, 20));
      local_owner.setText("");
      local_owner.setBounds(new Rectangle(38, 283, 188, 21));
      panel1.add(jPanel1, BorderLayout.SOUTH);
      jPanel1.add(b_OK, null);
      jPanel1.add(b_CANCEL, null);
      jPanel1.add(statusBar, null);
      panel1.add(panel2, BorderLayout.CENTER);
      panel2.add(local_path, null);
      panel2.add(local_path_browse, null);
      panel2.add(jLabel2, null);
      panel2.add(jLabel1, null);
      panel2.add(jLabel3, null);
      panel2.add(jLabel4, null);
      panel2.add(project_name, null);
      panel2.add(jScrollPane1, null);
      panel2.add(cb_project_leader, null);
      panel2.add(jLabel5, null);
      panel2.add(local_owner, null);
      jScrollPane1.getViewport().add(l_project_members, null);
    getContentPane().add(panel1);
   }

   //true if window is closed using OK button
   public boolean getOK()
   {
      return(OK);
   }

   public String getProjectName()
   {
      return(project_name.getText());
   }

   public void setProjectName(String name)
   {
      project_name.setText(name);
   }

   public void setLocalOwner(String owner)
   {
      local_owner.setText(owner);
   }

   public String getLocalPath()
   {
      return(local_path.getText());
   }

   public void setLocalPath(String path)
   {
      local_path.setText(path);
   }

   public String getProjectLeader()
   {
      return((String)cb_project_leader.getSelectedItem());
   }

   public void setProjectLeader(String leader)
   {
      cb_project_leader.setSelectedItem(leader);
   }

   public String[] getProjectMembers()
   {
      int selected[];
      int len;
      int i;

      selected=l_project_members.getSelectedIndices();
      len=l_project_members.getSelectedIndices().length;
      String users[]=new String[len];
      for (i=0; i<len; i++)
      {
         users[i]=(String)l_project_members.getModel().getElementAt(selected[i]);
      }
      return(users);
   }

   void b_CANCEL_actionPerformed(ActionEvent e)
   {
      this.setVisible(false);
   }

   void b_OK_actionPerformed(ActionEvent e)
   {
      //validacia poloziek
      if (project_name.getText().length()<1)
      {
         JOptionPane.showMessageDialog(this, "You must select project name.", "Error", JOptionPane.ERROR_MESSAGE);
         return;
      }
      if (local_path.getText().length()<1)
      {
         JOptionPane.showMessageDialog(this, "You must select local path.", "Error", JOptionPane.ERROR_MESSAGE);
         return;
      }
      if (l_project_members.getSelectedIndices().length<1)
      {
         JOptionPane.showMessageDialog(this, "You must select project members.", "Error", JOptionPane.ERROR_MESSAGE);
         return;
      }
      if (cb_project_leader.getSelectedIndex()<0)
      {
         JOptionPane.showMessageDialog(this, "You must select project leader.", "Error", JOptionPane.ERROR_MESSAGE);
         return;
      }

      this.setVisible(false);
      OK=true;
   }

   void local_path_browse_actionPerformed(ActionEvent e)
   {
      JFileChooser fc = new JFileChooser();
      //projectFilter  filter = new projectFilter();
      fc.setMultiSelectionEnabled(false);
      fc.setDialogTitle("Select local path for project");
      //fc.setFileFilter(filter);
      fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
      //fc.setSelectedFile(new File(getProjectName()+".shp"));
      int returnVal = fc.showOpenDialog(this);

      if (returnVal == JFileChooser.APPROVE_OPTION)
      {
        System.out.println("Getting file");
        local_path.setText(fc.getSelectedFile().getAbsolutePath());
      }
   }
}

class NewProjectWizard_b_CANCEL_actionAdapter implements java.awt.event.ActionListener
{
   NewProjectWizard adaptee;

   NewProjectWizard_b_CANCEL_actionAdapter(NewProjectWizard adaptee)
   {
      this.adaptee = adaptee;
   }

   public void actionPerformed(ActionEvent e)
   {
      adaptee.b_CANCEL_actionPerformed(e);
   }
}

class NewProjectWizard_b_OK_actionAdapter implements java.awt.event.ActionListener
{
   NewProjectWizard adaptee;

   NewProjectWizard_b_OK_actionAdapter(NewProjectWizard adaptee)
   {
      this.adaptee = adaptee;
   }

   public void actionPerformed(ActionEvent e)
   {
      adaptee.b_OK_actionPerformed(e);
   }
}

class NewProjectWizard_local_path_browse_actionAdapter implements java.awt.event.ActionListener
{
   NewProjectWizard adaptee;

   NewProjectWizard_local_path_browse_actionAdapter(NewProjectWizard adaptee)
   {
      this.adaptee = adaptee;
   }

   public void actionPerformed(ActionEvent e)
   {
      adaptee.local_path_browse_actionPerformed(e);
   }
}


