/*
 * ProjectDirFilter.java - accept only file in project directory
 * Copyright (C) 1999-2000 Lubos Balat
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


package sk.jeeff.shed.gui;

import javax.swing.filechooser.*;
import java.util.*;
import java.io.*;

import sk.jeeff.shed.*;

public class ProjectDirFilter extends javax.swing.filechooser.FileFilter
{

   String projectHome="g:\\projects";

   public ProjectDirFilter(String localPath)
   {
      super();
      projectHome = ShedTools.convertPathSeparatorToSystem(localPath).toLowerCase();
   }

   public boolean accept(File f)
   {
      //if (f.isDirectory()) return(true);
      String path = f.getAbsolutePath();
      path=path.toLowerCase();
      //System.out.println("path="+path);
      if (path.startsWith(projectHome))
      {
         //System.out.println("OK");
         return(true);
      }
      //System.out.println("home="+projectHome);
      return false;
   }

   // The description of this filter
   public String getDescription()
   {
      return "Shed project dir file";
   }

}