/*
 * ShedFileChooser.java - file chooser, which accepts only files in current project dir
 * Copyright (C) 1999-2000 Lubos Balat
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


package sk.jeeff.shed.gui;

import javax.swing.*;
import java.io.*;

import sk.jeeff.shed.*;

public class ShedFileChooser extends JFileChooser
{
   private String projectRoot="";

   public void setProjectRoot(String projectRoot)
   {
      this.projectRoot = ShedTools.convertPathSeparatorToSystem(projectRoot).toLowerCase();
   }

   public String getFile()
   {
      String filename;
      try
      {
         filename=getSelectedFile().getAbsolutePath();
      }
      catch (Exception e)
      {
         return("");
      }
      if (filename.toLowerCase().startsWith(projectRoot))
      {
         filename=filename.substring(projectRoot.length()+1);
         filename=ShedTools.convertPathSeparatorToInternal(filename);
         return (filename);
      }
      else return("");
   }


}