/*
 * f_main.java - main window for shed
 * Copyright (C) 1999-2000 Lubos Balat
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package sk.jeeff.shed.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.text.MutableAttributeSet;

import sk.jeeff.shed.gui.*;
import sk.jeeff.shed.client.*;
import sk.jeeff.shed.*;
import sk.jeeff.shed.project.*;
import sk.jeeff.shed.parser.*;

import javax.swing.border.*;
import javax.swing.JList;
import java.util.*;
import java.io.*;

public class f_main extends JFrame
{
   JMenuBar menuBar1 = new JMenuBar();
   JMenu menuFile = new JMenu();
   JMenuItem menuFileExit = new JMenuItem();
   JMenu menuHelp = new JMenu();
   JMenuItem menuHelpAbout = new JMenuItem();
   JToolBar toolBar = new JToolBar();
   JButton jButton1 = new JButton();
   JButton jButton2 = new JButton();
   JButton jButton3 = new JButton();
   ImageIcon image1;
   ImageIcon image2;
   ImageIcon image3;
   private JLabel statusBar = new JLabel();
   BorderLayout borderLayout1 = new BorderLayout();

   //project
   public ProjectInfo project = new ProjectInfo();
   private File projectFileName=null;

   //sietovy client
   public Client client=new Client(this);

   //novy riadok
   private String newline = "\n";


   JTabbedPane jTabbedPane1 = new JTabbedPane();
   JPanel jPanel1 = new JPanel();
   JPanel jPanel2 = new JPanel();
   JButton jButton4 = new JButton();
   //JPanel filesTree = new JPanel();
   FilesTree filesTree;

   BorderLayout borderLayout2 = new BorderLayout();
   JLabel jLabel1 = new JLabel();
   JButton jButton5 = new JButton();

   //BLBOST LEN TEST NA PRIDANIE
   private int newNodeSuffix = 1;

   JPanel connectPanel = new JPanel();
   public JTextField name_txt = new JTextField();
   JButton b_connect = new JButton();
   public JTextField chat_line = new JTextField();
   public DefaultComboBoxModel c_projects = new DefaultComboBoxModel();
   JComboBox cb_cb_projects = new JComboBox(c_projects);
   public DefaultListModel l_files = new DefaultListModel();

   //current connected user list
   public DefaultListModel l_user_list = new DefaultListModel();
   JList l_l_user_list = new JList(l_user_list);
   public String user_id_list[];

   //chat board
   JTextPane chat_board;
   Document chat_board_document;

   JTextField server_url = new JTextField();
   JPanel chatPanel = new JPanel();
   BorderLayout borderLayout3 = new BorderLayout();
   TitledBorder chatUsersBorder;
   TitledBorder chatBorder;
   JScrollPane jScrollPane1 = new JScrollPane();
   JLabel jLabel2 = new JLabel();
   JButton b_dwn_project = new JButton();
   JPanel projectsPanel = new JPanel();
   TitledBorder projectsBorder;
   JMenuItem menuFileNewProject = new JMenuItem();
   JMenuItem menuFileOpenProject = new JMenuItem();
   JMenuItem menuFileSaveProject = new JMenuItem();
   JMenu menuProject = new JMenu();
   JMenuItem menuProjectUploadToServer = new JMenuItem();
   JMenuItem menuProjectDownloadFromServer = new JMenuItem();
   JPanel jPanel3 = new JPanel();
   TitledBorder treeOperations;
   JButton treeAdd = new JButton();
   JButton treeRemove = new JButton();
   JButton treeProperties = new JButton();
   JMenuItem menuFileSaveProjectAs = new JMenuItem();
   JButton treePut = new JButton();
   JButton treeGet = new JButton();
   JButton treeAllocate = new JButton();
   JButton treeUnAllocate = new JButton();
   JLabel jLabel3 = new JLabel();
   JLabel jLabel4 = new JLabel();
   JButton b_test = new JButton();
   JLabel jLabel5 = new JLabel();
   public JPasswordField password_txt = new JPasswordField();
   JPanel jPanel4 = new JPanel();
   JLabel jLabel6 = new JLabel();
   public JLabel l_locked_by = new JLabel();
   JLabel jLabel7 = new JLabel();
   public JLabel l_locked_date = new JLabel();
   JLabel jLabel8 = new JLabel();
   JLabel jLabel9 = new JLabel();
   public JLabel l_created_by = new JLabel();
   public JLabel l_created_date = new JLabel();

   private String myFullName="";

   //Construct the frame
  public f_main()
   {
      try
      {
         UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
      }
      catch(Exception e)
      {
      }
      enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      try
      {
         jbInit();
      }
      catch(Exception e)
      {
         e.printStackTrace();
      }
      //filesTree.napln("project1");
   }

   //Component initialization
  private void jbInit() throws Exception
  {

      //chat_board_document = chat_board.getStyledDocument();
      chat_board = createTextPane();


      //System.out.println(sk.jeeff.shed.gui.f_mail.class.);
      image1 = new ImageIcon(sk.jeeff.shed.gui.f_main.class.getResource("openFile.gif"));
      image2 = new ImageIcon(sk.jeeff.shed.gui.f_main.class.getResource("closeFile.gif"));
      image3 = new ImageIcon(sk.jeeff.shed.gui.f_main.class.getResource("help.gif"));
      chatUsersBorder = new TitledBorder("Users");
      chatBorder = new TitledBorder("Messages");
      projectsBorder = new TitledBorder("");
      treeOperations = new TitledBorder("");
      this.getContentPane().setLayout(borderLayout1);
      this.setSize(new Dimension(570, 448));
      this.setTitle("SHED");
      statusBar.setText(" ");
      menuFile.setText("File");
      menuFileExit.setText("Exit");
      menuFileExit.addActionListener(new ActionListener()
      {

         public void actionPerformed(ActionEvent e)
         {
            fileExit_actionPerformed(e);
         }
      });
      menuHelp.setText("Help");
      menuHelpAbout.setText("About");
      menuHelpAbout.addActionListener(new ActionListener()
      {

         public void actionPerformed(ActionEvent e)
         {
            helpAbout_actionPerformed(e);
         }
      });
      jButton1.setIcon(image1);
      jButton1.setToolTipText("Open File");
      jButton2.setIcon(image2);
      jButton2.setToolTipText("Close File");
      jButton3.setIcon(image3);
      jButton3.setToolTipText("Help");
      jButton4.setText("jButton4");
      jButton4.setBounds(new Rectangle(22, 14, 122, 27));
      jButton4.addActionListener(new java.awt.event.ActionListener()
      {

         public void actionPerformed(ActionEvent e)
         {
            jButton4_actionPerformed(e);
         }
      });
      jPanel1.setLayout(null);
      jPanel2.setLayout(borderLayout2);
      //filesTree.setBorder(BorderFactory.createEtchedBorder());
      filesTree = new FilesTree(this);
      jLabel1.setText("Files in project:");
      jButton5.setText("jButton5");
      jButton5.setBounds(new Rectangle(23, 59, 120, 29));
      jButton5.addActionListener(new java.awt.event.ActionListener()
      {

         public void actionPerformed(ActionEvent e)
         {
            jButton5_actionPerformed(e);
         }
      });
      connectPanel.setLayout(null);
      name_txt.setText("jeeff");
      name_txt.setBounds(new Rectangle(13, 33, 134, 21));
      b_connect.setText("Connect");
      b_connect.setBounds(new Rectangle(208, 72, 107, 25));
      b_connect.addActionListener(new java.awt.event.ActionListener()
      {

         public void actionPerformed(ActionEvent e)
         {
            b_connect_actionPerformed(e);
         }
      });
      chat_line.setText("");
      chat_line.addActionListener(new java.awt.event.ActionListener()
      {

         public void actionPerformed(ActionEvent e)
         {
            chat_line_actionPerformed(e);
         }
      });
      cb_cb_projects.setBounds(new Rectangle(8, 42, 214, 24));
      cb_cb_projects.addItemListener(new java.awt.event.ItemListener()
      {

         public void itemStateChanged(ItemEvent e)
         {
            cb_cb_projects_itemStateChanged(e);
         }
      });
      chat_board.setBorder(null);
      chat_board.setNextFocusableComponent(chat_line);
      chat_board.setEditable(false);
      server_url.setText("localhost");
      server_url.setBounds(new Rectangle(180, 33, 136, 20));
      chatPanel.setLayout(borderLayout3);
      l_l_user_list.setBorder(chatUsersBorder);
      l_l_user_list.setMinimumSize(new Dimension(150, 0));
      l_l_user_list.setPreferredSize(new Dimension(150, 0));
      //l_l_user_list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      jScrollPane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
      jScrollPane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
      jScrollPane1.setBorder(chatBorder);
      jLabel2.setText("Available projects on server:");
      jLabel2.setBounds(new Rectangle(7, 19, 224, 20));
      b_dwn_project.setText("Download");
      b_dwn_project.setBounds(new Rectangle(146, 81, 108, 27));
      b_dwn_project.addActionListener(new java.awt.event.ActionListener()
      {
         public void actionPerformed(ActionEvent e)
         {
            b_dwn_project_actionPerformed(e);
         }
      });
      projectsPanel.setBorder(projectsBorder);
      projectsPanel.setBounds(new Rectangle(20, 135, 263, 120));
      projectsPanel.setLayout(null);
      projectsBorder.setTitle("Projects");
      menuFileNewProject.setText("New Project");
      menuFileNewProject.addActionListener(new java.awt.event.ActionListener()
      {

         public void actionPerformed(ActionEvent e)
         {
            menuFileNewProject_actionPerformed(e);
         }
      });
      menuFileOpenProject.setText("Open Project");
      menuFileOpenProject.addActionListener(new java.awt.event.ActionListener()
      {

         public void actionPerformed(ActionEvent e)
         {
            menuFileOpenProject_actionPerformed(e);
         }
      });
      menuFileSaveProject.setText("Save Project");
      menuFileSaveProject.addActionListener(new java.awt.event.ActionListener()
      {

         public void actionPerformed(ActionEvent e)
         {
            menuFileSaveProject_actionPerformed(e);
         }
      });
      menuProject.setText("Project");
      menuProjectUploadToServer.setText("Upload Files To Server");
      menuProjectUploadToServer.addActionListener(new java.awt.event.ActionListener()
      {

         public void actionPerformed(ActionEvent e)
         {
            menuProjectUploadToServer_actionPerformed(e);
         }
      });
      menuProjectDownloadFromServer.setText("Download Files From Server");
      menuProjectDownloadFromServer.addActionListener(new java.awt.event.ActionListener()
      {

         public void actionPerformed(ActionEvent e)
         {
            menuProjectDownloadFromServer_actionPerformed(e);
         }
      });
      jPanel3.setBorder(treeOperations);
      jPanel3.setMinimumSize(new Dimension(150, 10));
      jPanel3.setPreferredSize(new Dimension(150, 10));
      jPanel3.setLayout(null);
      treeOperations.setTitle("Operations");
      treeAdd.setText("Add");
      treeAdd.setBounds(new Rectangle(28, 26, 102, 27));
      treeAdd.addActionListener(new java.awt.event.ActionListener()
      {

         public void actionPerformed(ActionEvent e)
         {
            treeAdd_actionPerformed(e);
         }
      });
      treeRemove.setText("Remove");
      treeRemove.setBounds(new Rectangle(28, 56, 102, 27));
      treeRemove.addActionListener(new f_main_treeRemove_actionAdapter(this));
      treeProperties.setText("Properties");
      treeProperties.setBounds(new Rectangle(28, 86, 102, 27));
      treeProperties.addActionListener(new f_main_treeProperties_actionAdapter(this));
      menuFileSaveProjectAs.setText("Save Project As");
      menuFileSaveProjectAs.addActionListener(new java.awt.event.ActionListener()
      {

         public void actionPerformed(ActionEvent e)
         {
            menuFileSaveProjectAs_actionPerformed(e);
         }
      });
      treePut.setText("Put");
      treePut.setBounds(new Rectangle(28, 120, 102, 27));
      treePut.addActionListener(new java.awt.event.ActionListener()
      {

         public void actionPerformed(ActionEvent e)
         {
            treePut_actionPerformed(e);
         }
      });
      treeGet.setText("Get");
      treeGet.setBounds(new Rectangle(28, 150, 102, 27));
      treeGet.addActionListener(new java.awt.event.ActionListener()
      {

         public void actionPerformed(ActionEvent e)
         {
            treeGet_actionPerformed(e);
         }
      });
      treeAllocate.setText("Allocate");
      treeAllocate.setBounds(new Rectangle(28, 185, 102, 27));
      treeAllocate.addActionListener(new java.awt.event.ActionListener()
      {

         public void actionPerformed(ActionEvent e)
         {
            treeAllocate_actionPerformed(e);
         }
      });
      treeUnAllocate.setText("UnAllocate");
      treeUnAllocate.setBounds(new Rectangle(28, 215, 102, 27));
      treeUnAllocate.addActionListener(new java.awt.event.ActionListener()
      {

         public void actionPerformed(ActionEvent e)
         {
            treeUnAllocate_actionPerformed(e);
         }
      });
      jPanel1.setEnabled(false);
      jLabel3.setText("Login Name:");
      jLabel3.setBounds(new Rectangle(12, 11, 133, 20));
      jLabel4.setText("Hostname:");
      jLabel4.setBounds(new Rectangle(180, 14, 135, 18));
      b_test.setText("test");
      b_test.setBounds(new Rectangle(28, 253, 102, 24));
      b_test.addMouseListener(new java.awt.event.MouseAdapter()
      {

         public void mouseClicked(MouseEvent e)
         {
            b_test_mouseClicked(e);
         }
      });
      jLabel5.setText("Password:");
      jLabel5.setBounds(new Rectangle(13, 60, 134, 17));
      password_txt.setText("jeeff");
      password_txt.setPreferredSize(new Dimension(36, 21));
      password_txt.setBounds(new Rectangle(13, 77, 134, 20));
      jPanel4.setLayout(null);
      jPanel4.setMinimumSize(new Dimension(1, 35));
      jPanel4.setPreferredSize(new Dimension(1, 35));
      jLabel6.setMaximumSize(new Dimension(60, 12));
      jLabel6.setMinimumSize(new Dimension(60, 12));
      jLabel6.setPreferredSize(new Dimension(60, 12));
      jLabel6.setText("Locked by:");
      jLabel6.setBounds(new Rectangle(1, 3, 68, 15));
      l_locked_by.setMaximumSize(new Dimension(38, 12));
      l_locked_by.setMinimumSize(new Dimension(38, 12));
      l_locked_by.setPreferredSize(new Dimension(38, 12));
      l_locked_by.setBounds(new Rectangle(90, 3, 162, 15));
      jLabel7.setText("Locked Date:");
      jLabel7.setBounds(new Rectangle(1, 17, 88, 17));
      l_locked_date.setMaximumSize(new Dimension(38, 12));
      l_locked_date.setMinimumSize(new Dimension(38, 12));
      l_locked_date.setPreferredSize(new Dimension(38, 15));
      l_locked_date.setBounds(new Rectangle(90, 17, 160, 17));
      jLabel8.setMaximumSize(new Dimension(64, 12));
      jLabel8.setMinimumSize(new Dimension(64, 12));
      jLabel8.setPreferredSize(new Dimension(64, 15));
      jLabel8.setText("Created by:");
      jLabel8.setBounds(new Rectangle(259, 3, 73, 16));
      jLabel9.setMaximumSize(new Dimension(77, 12));
      jLabel9.setMinimumSize(new Dimension(77, 12));
      jLabel9.setPreferredSize(new Dimension(77, 15));
      jLabel9.setText("Created Date:");
      jLabel9.setBounds(new Rectangle(259, 17, 98, 17));
      l_created_by.setMaximumSize(new Dimension(38, 12));
      l_created_by.setMinimumSize(new Dimension(38, 12));
      l_created_by.setPreferredSize(new Dimension(154, 15));
      l_created_by.setBounds(new Rectangle(361, 3, 154, 18));
      l_created_date.setMaximumSize(new Dimension(38, 12));
      l_created_date.setMinimumSize(new Dimension(38, 12));
      l_created_date.setPreferredSize(new Dimension(166, 15));

      l_created_date.setBounds(new Rectangle(361, 16, 166, 17));
      toolBar.add(jButton1);
      toolBar.add(jButton2);
      toolBar.add(jButton3);
      menuFile.add(menuFileNewProject);
      menuFile.add(menuFileOpenProject);
      menuFile.addSeparator();
      menuFile.add(menuFileSaveProject);
      menuFile.add(menuFileSaveProjectAs);
      menuFile.addSeparator();
      menuFile.add(menuFileExit);
      menuHelp.add(menuHelpAbout);
      menuBar1.add(menuFile);

      //--- project menu -------------
      //menuBar1.add(menuProject);
      menuBar1.add(menuHelp);
      this.setJMenuBar(menuBar1);
      this.getContentPane().add(toolBar, BorderLayout.NORTH);
      this.getContentPane().add(statusBar, BorderLayout.SOUTH);
      this.getContentPane().add(jTabbedPane1, BorderLayout.CENTER);
      //jTabbedPane1.add(jPanel1, "-*-debug-*-");
      jPanel1.add(jButton4, null);
      jPanel1.add(jButton5, null);
      jTabbedPane1.add(jPanel2, "Project");
      jPanel2.add(filesTree, BorderLayout.CENTER);
      jPanel2.add(jLabel1, BorderLayout.NORTH);
      jPanel2.add(jPanel3, BorderLayout.EAST);
      jPanel3.add(treeAdd, null);
      jPanel3.add(treeRemove, null);
      jPanel3.add(treeProperties, null);
      jPanel3.add(treePut, null);
      jPanel3.add(treeGet, null);
      jPanel3.add(treeAllocate, null);
      jPanel3.add(treeUnAllocate, null);
      jPanel3.add(b_test, null);
      jPanel2.add(jPanel4, BorderLayout.SOUTH);
      jPanel4.add(jLabel6, null);
      jPanel4.add(l_locked_by, null);
      jPanel4.add(l_locked_date, null);
      jPanel4.add(jLabel7, null);
      jPanel4.add(jLabel8, null);
      jPanel4.add(l_created_date, null);
      jPanel4.add(l_created_by, null);
      jPanel4.add(jLabel9, null);
      jTabbedPane1.add(connectPanel, "Connect");
      connectPanel.add(server_url, null);
      connectPanel.add(name_txt, null);
      connectPanel.add(jLabel3, null);
      connectPanel.add(jLabel4, null);
      connectPanel.add(projectsPanel, null);
      projectsPanel.add(cb_cb_projects, null);
      projectsPanel.add(jLabel2, null);
      projectsPanel.add(b_dwn_project, null);
      connectPanel.add(jLabel5, null);
      connectPanel.add(password_txt, null);
      connectPanel.add(b_connect, null);

      jTabbedPane1.add(chatPanel, "Chat");
      chatPanel.add(chat_line, BorderLayout.SOUTH);
      chatPanel.add(l_l_user_list, BorderLayout.EAST);
      chatPanel.add(jScrollPane1, BorderLayout.CENTER);
      jScrollPane1.getViewport().add(chat_board, null);
      menuProject.add(menuProjectDownloadFromServer);
      menuProject.add(menuProjectUploadToServer);
   }

   private JTextPane createTextPane()
   {
        JTextPane textPane = new JTextPane();
        initStylesForTextPane(textPane);
        chat_board_document = textPane.getDocument();
        return textPane;
    }

   protected void initStylesForTextPane(JTextPane textPane) {
        //Initialize some styles.
        Style def = StyleContext.getDefaultStyleContext().getStyle(StyleContext.DEFAULT_STYLE);

        Style regular = textPane.addStyle("regular", def);
        StyleConstants.setFontFamily(def, "SansSerif");

        Style s = textPane.addStyle("italic", regular);
        StyleConstants.setItalic(s, true);

        s = textPane.addStyle("bold", regular);
        StyleConstants.setBold(s, true);

        s = textPane.addStyle("small", regular);
        StyleConstants.setFontSize(s, 10);

        s = textPane.addStyle("large", regular);
        StyleConstants.setFontSize(s, 16);

        //StyleConstants.setComponent(s, button);
    }


   //add message to chat board
   public void chatBoardAdd(String from, String text)
   {
      try
      {
         //System.out.println(chat_board_document.getLength());
         chat_board_document.insertString(chat_board_document.getLength(), "<"+from+"> ", chat_board.getStyle("bold"));
         chat_board_document.insertString(chat_board_document.getLength(), text+newline, chat_board.getStyle("regular"));
      }
      catch (Exception ex)
      {
         setStatusBar("Error: Can't add text to chat board... " + ex.getMessage());
      }
   }

   //open file path in editor
   public void editFile(String path)
   {
      setStatusBar("Opening editor, please wait.");
      System.out.println("Opening file"+path);
      setStatusBar("Editor opened.");
   }


   //File | Exit action performed
   public void fileExit_actionPerformed(ActionEvent e)
   {
      //menuFileSaveProject_actionPerformed(null);
      System.exit(0);
   }

   //Help | About action performed
   public void helpAbout_actionPerformed(ActionEvent e)
   {
      f_main_AboutBox dlg = new f_main_AboutBox(this);
      Dimension dlgSize = dlg.getPreferredSize();
      Dimension frmSize = getSize();
      Point loc = getLocation();
      dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
      dlg.setModal(true);
      dlg.show();
   }

   //Overridden so we can exit on System Close
   protected void processWindowEvent(WindowEvent e)
   {
      super.processWindowEvent(e);
      if(e.getID() == WindowEvent.WINDOW_CLOSING)
      {
         fileExit_actionPerformed(null);
      }
   }

   void jButton4_actionPerformed(ActionEvent e)
   {
      parseFileForElements();
   }

   void jButton5_actionPerformed(ActionEvent e)
   {
      //filesTree.addObject("New Node " + newNodeSuffix++);

      //filesTree.readFromVector(project.getProjectTree());
      System.out.println("Put file: ret="+client.putFile(chat_line.getText()));
   }

   void b_connect_actionPerformed(ActionEvent e)
   {
      if (!client.isConnected())
      {
         if (client.connect(server_url.getText())==1)
         {
            b_connect.setText("Disconnect");
            if (project.getProjectName().length()>0)
            {
               System.out.println("SENDING1");
               client.send("/set_project#"+project.getProjectName());
               System.out.println("SENDING2");
               client.getUserList();
               System.out.println("SENDING3");
            }
            client.send("/listprojects");
         }
      }
      else
      {
         if (client.disconnect()==1)
         {
            b_connect.setText("Connect");
            c_projects.removeAllElements();
            l_files.removeAllElements();
            l_user_list.removeAllElements();

         }

      }
   }

   public void disconnect()
   {
      if (client.disconnect()==1)
      {
         b_connect.setText("Connect");
         c_projects.removeAllElements();
         l_files.removeAllElements();
         l_user_list.removeAllElements();
      }
   }

   void cb_cb_projects_itemStateChanged(ItemEvent e)
   {
      //setStatusBar("Selected project: "+c_projects.getSelectedItem());
   }

   //user press ENTER in chat line
   void chat_line_actionPerformed(ActionEvent e)
   {
      if (chat_line.getText().length()>0)
      {
         //setStatusBar("Message: "+chat_line.getText());
         //chat_board.append("\n"+"<jano> "+chat_line.getText());
         //chatBoardAdd("jano", chat_line.getText());
         //String msg_for=(String)l_l_user_list.getSelectedValue();

         if (l_l_user_list.getSelectedIndex()!=-1)
         {
            client.send_msg(user_id_list[l_l_user_list.getSelectedIndex()], chat_line.getText());
         }
         //if no one is selected, send for all users
         else client.send_msg("-1", chat_line.getText());
         chat_line.setText("");
      }
   }

   void menuFileNewProject_actionPerformed(ActionEvent e)
   {
      if (!client.isConnected())
      {
         JOptionPane.showMessageDialog(this, "You are not connected to server.", "Error", JOptionPane.ERROR_MESSAGE);
         return;
      }

      NewProjectWizard dlg = new NewProjectWizard(this, "New Project Wizard", true);
      Dimension dlgSize = dlg.getPreferredSize();
      Dimension frmSize = getSize();
      Point loc = getLocation();
      dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
      dlg.pack();
      dlg.show();
      System.out.println("Koniec editu"+dlg.getOK());
      //vytvorenie noveho projektu
      if (dlg.getOK())
      {
         if (client.createProject(dlg.getProjectName(), dlg.getProjectLeader(), dlg.getProjectMembers())==1)
         {
            project.setProjectName(dlg.getProjectName());
            project.setProjectLeader(dlg.getProjectLeader());
            project.setLocalPath(dlg.getLocalPath());
            project.setProjectMembers(dlg.getProjectMembers());
            project.setMyName(dlg.getProjectLeader());

            Vector defProject=new Vector();
            FileInfo root=new FileInfo(project.getProjectName()+".shp", FileInfo.PROJECT_ROOT, FileInfo.ALLOCATED_BY_ME);
            root.setOwner(dlg.getProjectLeader());
            defProject.add(root);
            project.setProjectTree(defProject);
            filesTree.readFromVector(project.getProjectTree());

            client.send("/set_project#"+project.getProjectName());
            client.send("/alloc_file#"+project.getProjectName()+".shp");
            setStatusBar("Project succesfully created");
         }
         else
         {
            setStatusBar("Error: Project with specified name already exist's");
         }
      }
      dlg.dispose();
      this.repaint();
   }

   public void clearProject(String projectName)
   {
      project.setProjectName(projectName);
      project.setProjectLeader("");
      project.setLocalPath("e:\\");
      String members[] = new String[1];
      members[0]="test";
      project.setProjectMembers(members);
      project.setMyName("test");

      Vector defProject=new Vector();
      FileInfo root=new FileInfo(project.getProjectName()+".shp", FileInfo.PROJECT_ROOT, FileInfo.ALLOCATED_FREE);
      root.setOwner("");
      defProject.add(root);
      project.setProjectTree(defProject);
      filesTree.readFromVector(project.getProjectTree());
   }

   public void clearProjectFiles(String projectName)
   {
      project.setProjectName(projectName);

      Vector defProject=new Vector();
      FileInfo root=new FileInfo(project.getProjectName()+".shp", FileInfo.PROJECT_ROOT, FileInfo.ALLOCATED_FREE);
      root.setOwner("");
      defProject.add(root);
      project.setProjectTree(defProject);
      filesTree.readFromVector(project.getProjectTree());
   }

   void menuFileOpenProject_actionPerformed(ActionEvent e)
   {
      JFileChooser fc = new JFileChooser();
      ProjectFilter  filter = new ProjectFilter();
      fc.setMultiSelectionEnabled(false);
      fc.setFileFilter(filter);
      int returnVal = fc.showOpenDialog(this);

      if (returnVal == JFileChooser.APPROVE_OPTION)
      {
         openProject(fc.getSelectedFile());
         System.out.println("menuFileOpenPROJECT: myName="+project.getMyName()+" path="+project.getLocalPath());
      }
   }

   //reopen project in file fileName
   private void reOpenProject(String fileName)
   {
      File f = new File(fileName);
      ProjectInfo newProject;
      String myName=project.getMyName();
      System.out.println("ReOpening project");
      try
      {
         FileInputStream in = new FileInputStream(f.getAbsolutePath());
         ObjectInputStream s = new ObjectInputStream(in);
         newProject = (ProjectInfo)s.readObject();
         s.close();
         in.close();
         //projectFileName=fileName;
         Vector tree=newProject.getProjectTree();
         project.setProjectTree(tree);
      } catch (Exception ex)
      {
         System.out.println("Chyba pri citani: " + ex.getMessage());
      }
      filesTree.readFromVector(project.getProjectTree());
      project.setMyName(myName);
      System.out.println("reOpenPROJECT 3: myName="+project.getMyName()+" path="+project.getLocalPath());

      filesTree.expandAll();

   }

   //open project in file fileName
   private void openProject(File fileName)
   {
      System.out.println("Loading file");
      try
      {
         FileInputStream in = new FileInputStream(fileName.getAbsolutePath());
         ObjectInputStream s = new ObjectInputStream(in);
         project = (ProjectInfo)s.readObject();
         s.close();
         in.close();
         projectFileName=fileName;

         project.setLocalPath(ShedTools.getOnlyPath(ShedTools.convertPathSeparatorToInternal(fileName.getPath())));

      } catch (Exception ex)
      {
         System.out.println("Chyba pri citani: " + ex.getMessage());
      }
      filesTree.readFromVector(project.getProjectTree());

      if (client.isConnected())
      {
         client.send("/set_project#"+project.getProjectName());
      }

      filesTree.expandAll();

   }

   void menuFileSaveProject_actionPerformed(ActionEvent e)
   {
      if (projectFileName==null || !projectFileName.exists())
      {
         menuFileSaveProjectAs_actionPerformed(e);
         return;
      }
      else
      {
         System.out.println("Saving file");
         setStatusBar("Saving project");

         project.setProjectTree(filesTree.storeToVector());

         try
         {
            FileOutputStream out = new FileOutputStream(projectFileName.getAbsolutePath());
            ObjectOutputStream s = new ObjectOutputStream(out);
            s.writeObject(project);
            s.flush();
            s.close();
            out.close();
            setStatusBar("Project saved");
         } catch (Exception ex)
         {
            System.out.println("Write error: " + ex.getMessage());
            setStatusBar("Can't save project file: "+ex.getMessage());
         }
      }
   }

   void menuFileSaveProjectAs_actionPerformed(ActionEvent e)
   {
      JFileChooser fc = new JFileChooser(project.getLocalPath());
      ProjectFilter  filter = new ProjectFilter();
      fc.setMultiSelectionEnabled(false);
      fc.setFileFilter(filter);
      fc.setSelectedFile(new File(project.getProjectName()+".shp"));
      int returnVal = fc.showSaveDialog(this);

      if (returnVal == JFileChooser.APPROVE_OPTION)
      {
         System.out.println("Saving file");
         setStatusBar("Saving project");

         project.setProjectTree(filesTree.storeToVector());

         try
         {
            FileOutputStream out = new FileOutputStream(fc.getSelectedFile().getAbsolutePath());
            ObjectOutputStream s = new ObjectOutputStream(out);
            s.writeObject(project);
            s.flush();
            s.close();
            out.close();
            projectFileName=fc.getSelectedFile();
            setStatusBar("Project saved");
         } catch (Exception ex)
         {
            System.out.println("Write error: " + ex.getMessage());
            setStatusBar("Can't save project file: "+ex.getMessage());
         }


      }

   }

   //download all files in project from server
   void menuProjectDownloadFromServer_actionPerformed(ActionEvent e)
   {
      if (!client.isConnected())
      {
         JOptionPane.showMessageDialog(this, "You are not connected to server.", "Error", JOptionPane.ERROR_MESSAGE);
         return;
      }

      setStatusBar("Loading project from server");
      downloadFromServer(project.getProjectTree());
   }

   //TODO: osetrit zly download
   //TODO: downloadnut iba subory, ktore nie su moje
   private int downloadFromServer(Vector tree)
   {
      FileInfo fileInfo;
      System.out.println("Downloading from server");
      for (int i=0; i<tree.size(); i++)
      {
         if (tree.elementAt(i) instanceof FileInfo)
         {
            fileInfo = (FileInfo)tree.elementAt(i);
            if (fileInfo.getType()==FileInfo.FILE) // || fileInfo.getType()==FileInfo.SUB_FILE)
            {
               System.out.println("Get file: "+fileInfo.getFileName());
               int ret=client.getFile(fileInfo.getFilePath()+"/"+fileInfo.getFileName());
            }
         }
         else
         {
            System.out.print("subVektor: ");
            downloadFromServer((Vector)tree.elementAt(i));
         }
      }
      return(1);
   }


   void menuProjectUploadToServer_actionPerformed(ActionEvent e)
   {
      if (!client.isConnected())
      {
         JOptionPane.showMessageDialog(this, "You are not connected to server.", "Error", JOptionPane.ERROR_MESSAGE);
         return;
      }
      setStatusBar("Saving project to server");
      uploadToServer(project.getProjectTree());
   }

   //TODO: osetrit zly save
   //TODO: uploadnut iba moje veci!!!
   private int uploadToServer(Vector tree)
   {
      FileInfo fileInfo;

      for (int i=0; i<tree.size(); i++)
      {
         if (tree.elementAt(i) instanceof FileInfo)
         {
            fileInfo = (FileInfo)tree.elementAt(i);
            if (fileInfo.getType()==FileInfo.FILE || fileInfo.getType()==FileInfo.SUB_FILE)
            {
               int ret=client.putFile(fileInfo.getFilePath()+"/"+fileInfo.getFileName());
               System.out.println("Put file: ret="+ret);
            }
         }
         else
         {
            System.out.print("subVektor: ");
            uploadToServer((Vector)tree.elementAt(i));
         }
      }
      return(1);
   }

   //add entity to project tree
   void treeAdd_actionPerformed(ActionEvent e)
   {
      if (!client.isConnected())
      {
         JOptionPane.showMessageDialog(this, "You are not connected to server.", "Error", JOptionPane.ERROR_MESSAGE);
         return;
      }

      if (!filesTree.getRootFileInfo().isMine())
      {
         //JOptionPane.showMessageDialog(this, "You must allocate project first.", "Error", JOptionPane.ERROR_MESSAGE);
         //return;
      }

      FileInfoPropertiesDialog dlg = new FileInfoPropertiesDialog(this, "FileInfo", true);
      Dimension dlgSize = dlg.getPreferredSize();
      Dimension frmSize = getSize();
      Point loc = getLocation();
      dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);

      if (filesTree.getSelectedFileInfo().getType()==FileInfo.FILE || filesTree.getSelectedFileInfo().getType()==FileInfo.SUB_FILE)
      {
         dlg.setFileName(filesTree.getSelectedFileInfo().getPathWithFile());
         dlg.setType(FileInfo.SUB_FILE);
      }
      else dlg.setType(FileInfo.FILE);

      dlg.pack();
      dlg.show();
      System.out.println("Koniec editu"+dlg.getOK());
      //vytvorenie noveho projektu
      if (dlg.getOK())
      {
         FileInfo fileInfo=new FileInfo(dlg.getFileName(), dlg.getType(), FileInfo.ALLOCATED_BY_ME);
         //add new element
         if (dlg.getType()==FileInfo.SUB_FILE)
         {
            if (filesTree.getSelectedFileInfo().getType()==FileInfo.DIR || filesTree.getSelectedFileInfo().getType()==FileInfo.PROJECT_ROOT)
            {
               JOptionPane.showMessageDialog(this, "You can't add element here.", "Error", JOptionPane.ERROR_MESSAGE);
               return;
            }
            fileInfo.setElementName(dlg.getElementName());
            String afterElementName="";
            //fileInfo.setOwner("");
            if (filesTree.getSelectedFileInfo().getType()==FileInfo.SUB_FILE)
            {
               afterElementName=filesTree.getSelectedFileInfo().getElementName();
            }
            //DEFAULTNE AK NIE JE AFTER ELEMENT DA HO NA ZACIATOK SUBORU
            /*if (filesTree.getSelectedFileInfo().getType()==FileInfo.FILE)
            {
               afterElementName="";
               String elementNames = filesTree.getElementNames();
               if (elementNames.length() > 1)
               {
                  StringTokenizer st_elementNames = new StringTokenizer(elementNames, "#");
                  afterElementName = st_elementNames.nextToken();
               }
            } */
            if (client.createNewElement(dlg.getFileName(), dlg.getElementName(), afterElementName)==1)
            {
               fileInfo.setOwner(project.getMyName());
               fileInfo.setCreator(project.getMyName());

               ElementParser parser = new ElementParser();
               parser.readFile( project.getLocalPath() + File.separatorChar + fileInfo.getPathWithFile());
               parser.allocElement(fileInfo.getElementName(), myFullName);

               //fileInfo.setOwner(project.getMyName());
               //filesTree.setCurrentNode(fileInfo);
               //menuFileSaveProject_actionPerformed(null);

               //filesTree.addObject(fileInfo);
            }
         }
         //add new file
         else if (dlg.getType()==FileInfo.FILE)
         {
            if (filesTree.getSelectedFileInfo().getType()==FileInfo.SUB_FILE || filesTree.getSelectedFileInfo().getType()==FileInfo.FILE)
            {
               JOptionPane.showMessageDialog(this, "You can't add file here.", "Error", JOptionPane.ERROR_MESSAGE);
               return;
            }
            if (client.createNewFile(dlg.getFileName())==1) filesTree.addObject(fileInfo, true);


            //if file already exists, we can try to parse it...
            File f = new File(ShedTools.convertPathSeparatorToSystem(project.getLocalPath()+"/"+fileInfo.getPathWithFile()));
            System.out.println("Testing if file exists: "+f.getAbsolutePath());
            if (f.exists() && f.length()>0)
            {
               int result = JOptionPane.showConfirmDialog(this,"File already exists. Do you wanna parse it for elements?","File already exists",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE);
               if (result == JOptionPane.YES_OPTION)
               {
                  parseFileForElements(fileInfo);
               }
            }

         }
         //add new dir
         else if (dlg.getType()==FileInfo.DIR)
         {
            if (filesTree.getSelectedFileInfo().getType()==FileInfo.SUB_FILE || filesTree.getSelectedFileInfo().getType()==FileInfo.FILE)
            {
               JOptionPane.showMessageDialog(this, "You can't add directory here.", "Error", JOptionPane.ERROR_MESSAGE);
               return;
            }
            filesTree.addObject(fileInfo);
         }

      }
      dlg.dispose();
      this.repaint();
   }

   //properties of entity
   void treeProperties_actionPerformed(ActionEvent e)
   {
      if (!client.isConnected())
      {
         JOptionPane.showMessageDialog(this, "You are not connected to server.", "Error", JOptionPane.ERROR_MESSAGE);
         return;
      }

      FileInfo fileInfo=filesTree.getSelectedFileInfo();

      if (!fileInfo.isMine())
      {
         JOptionPane.showMessageDialog(this, "You must allocate file first.", "Error", JOptionPane.ERROR_MESSAGE);
         return;
      }

      //file properties
      if (fileInfo.getType()==FileInfo.FILE)
      {

         FileInfoPropertiesDialog dlg = new FileInfoPropertiesDialog(this, "FileInfo", true);
         Dimension dlgSize = dlg.getPreferredSize();
         Dimension frmSize = getSize();
         Point loc = getLocation();
         dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);

         //nastavenie aktualnych hodnot
         dlg.setFileName(fileInfo.getFileName());
         dlg.setType(fileInfo.getType());
         dlg.pack();
         dlg.show();
         System.out.println("Koniec editu"+dlg.getOK());
         //vytvorenie noveho projektu
         if (dlg.getOK())
         {
            FileInfo newFileInfo=new FileInfo(dlg.getFileName(), dlg.getType(), FileInfo.ALLOCATED_BY_ME);
            filesTree.setCurrentNode(newFileInfo);
         }
         dlg.dispose();
         this.repaint();
      }
      //project properties
      else if (fileInfo.getType()==FileInfo.PROJECT_ROOT)
      {
/************ TODO: project members ***********/
         NewProjectWizard dlg = new NewProjectWizard(this, "Project Info", true);
         Dimension dlgSize = dlg.getPreferredSize();
         Dimension frmSize = getSize();
         Point loc = getLocation();
         dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);

         dlg.setLocalPath(project.getLocalPath());
         dlg.setProjectLeader(project.getProjectLeader());
         dlg.setProjectName(project.getProjectName());
         dlg.setLocalOwner(project.getMyName());
         dlg.pack();
         dlg.show();
         System.out.println("Koniec editu"+dlg.getOK());
         if (dlg.getOK())
         {
            project.setLocalPath(dlg.getLocalPath());
            project.setProjectLeader(dlg.getProjectLeader());
            project.setProjectName(dlg.getProjectName());
         }
         dlg.dispose();
         this.repaint();
      }

   }

   //remove entity from project tree
   //TODO: remove it from disc & server too
   void treeRemove_actionPerformed(ActionEvent e)
   {
      if (!client.isConnected())
      {
         JOptionPane.showMessageDialog(this, "You are not connected to server.", "Error", JOptionPane.ERROR_MESSAGE);
         return;
      }

      FileInfo fileInfo=filesTree.getSelectedFileInfo();

      if (!fileInfo.isMine())
      {
         JOptionPane.showMessageDialog(this, "You must allocate file first.", "Error", JOptionPane.ERROR_MESSAGE);
         return;
      }

      int n = JOptionPane.showConfirmDialog(this,"Do you really want to remove this item from project?","Remove item", JOptionPane.YES_NO_OPTION);
      if (n==JOptionPane.YES_OPTION)
      {
         filesTree.removeCurrentNode();
      }
   }

   //put entity to server
   void treePut_actionPerformed(ActionEvent e)
   {
      if (!client.isConnected())
      {
         JOptionPane.showMessageDialog(this, "You are not connected to server.", "Error", JOptionPane.ERROR_MESSAGE);
         return;
      }

      FileInfo fileInfo=filesTree.getSelectedFileInfo();

      int ret=0;
      //put project file
      if (fileInfo.getType()==FileInfo.PROJECT_ROOT)
      {
         /*if (projectFileName==null || !projectFileName.exists())
         {
            JOptionPane.showMessageDialog(this, "You must first save the project localy.", "Error", JOptionPane.ERROR_MESSAGE);
            return;
         }
         ret=client.putFileAs(fileInfo.getFilePath()+"/"+projectFileName.getName(), project.getProjectName()+".shp");
         System.out.println("Put project: ret="+ret);*/
      }
      //put file
      else if (fileInfo.getType()==FileInfo.FILE)
      {
         //test if file have elements...
         String elementNames=filesTree.getMineElementNames();
         if (elementNames!=null)
         {
            ret=1;
            StringTokenizer st_names=new StringTokenizer(elementNames, "#");
            boolean error=false;
            while (st_names.hasMoreTokens())
            {
               ret=client.putElement(fileInfo.getFilePath()+fileInfo.getFileName(), st_names.nextToken());
               if (ret==0) error=true;
            }
            if (error==true) ret=0;
         }
         else ret=client.putFile(fileInfo.getFilePath()+fileInfo.getFileName());
         System.out.println("Put file: ret="+ret);
      }
      //put element
      else if (fileInfo.getType()==FileInfo.SUB_FILE)
      {
         if (!fileInfo.isMine())
         {
            if (JOptionPane.showConfirmDialog(this, "You are not owner of this file. Are you shure to put this element to server?", "Error", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE) != JOptionPane.OK_OPTION)
            {
               return;
            }
         }
         ret=client.putElement(fileInfo.getFilePath()+fileInfo.getFileName(), fileInfo.getElementName());
      }
      if (ret!=0) setStatusBar("Upload succesful.");
      else setStatusBar("ERROR: can't upload file.");
   }

   //get entity from server
   void treeGet_actionPerformed(ActionEvent e)
   {
      if (!client.isConnected())
      {
         JOptionPane.showMessageDialog(this, "You are not connected to server.", "Error", JOptionPane.ERROR_MESSAGE);
         return;
      }

      FileInfo fileInfo=filesTree.getSelectedFileInfo();

      if (fileInfo.isMine())
      {
         if (JOptionPane.showConfirmDialog(this, "This entity is allocate by you, are you sure to get it from server again?.", "Error", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE) != JOptionPane.OK_OPTION)
         {
            return;
         }
      }

      int ret=0;
      //get file
      if (fileInfo.getType()==FileInfo.FILE)
      {
         //test if file have elements...
         String elementNames=filesTree.getMineElementNames();
         System.out.println("f_main.get MineElementNames="+elementNames);
         if (elementNames!=null && elementNames.length()>0)
         {
            //update element names in file
            elementNames=filesTree.getElementNames();
            if (elementNames!=null && elementNames.length()>0)
            {
               ElementParser parser = new ElementParser();
               parser.readFile(project.getLocalPath()+"/"+fileInfo.getFilePath()+"/"+fileInfo.getFileName(), elementNames);
               parser.writeFile();
            }

            elementNames=filesTree.getElementNamesNotMine();
            if (elementNames!=null)
            {
               ret=1;
               StringTokenizer st_names=new StringTokenizer(elementNames, "#");
               boolean error=false;
               while (st_names.hasMoreTokens())
               {
                  ret=client.getElement(fileInfo.getFilePath()+"/"+fileInfo.getFileName(), st_names.nextToken());
                  if (ret==0) error=true;
               }
               if (error==true) ret=0;
            }
         }
         else ret=client.getFile(fileInfo.getFilePath()+"/"+fileInfo.getFileName());
      }
      //get element
      else if (fileInfo.getType()==FileInfo.SUB_FILE)
      {
         //update element names in file
         String elementNames=filesTree.getElementNames();
         /*if (elementNames!=null && elementNames.length()>0)
         {
            ElementParser parser = new ElementParser();
            parser.readFile(project.getLocalPath()+"/"+fileInfo.getFilePath()+"/"+fileInfo.getFileName(), elementNames);
            parser.writeFile();
         } */
         ret=client.getElement(fileInfo.getFilePath()+"/"+fileInfo.getFileName(), fileInfo.getElementName());
      }
      //get project file
      else if (fileInfo.getType()==FileInfo.PROJECT_ROOT)
      {
         /*fileInfo=filesTree.getRootFileInfo();
         ret=client.getFile(fileInfo.getFilePath()+"/"+fileInfo.getFileName());

         if (ret==1)
         {
            reOpenProject(this.internalToSystemPathSeparator(project.getLocalPath()+"/"+fileInfo.getFileName()));
         } */
         //project.setProjectTree(filesTree.storeToVector());
         //downloadFromServer(project.getProjectTree());
         //ret = 1;
      }
      System.out.println("Get file: ret="+ret);
      if (ret!=0) setStatusBar("Download succesful.");
      else setStatusBar("ERROR: can't download file.");
   }

   //allocate entity
   void treeAllocate_actionPerformed(ActionEvent e)
   {
      if (!client.isConnected())
      {
         JOptionPane.showMessageDialog(this, "You are not connected to server.", "Error", JOptionPane.ERROR_MESSAGE);
         return;
      }

      FileInfo fileInfo=filesTree.getSelectedFileInfo();

      //test ci je alokovany, ale nie je to root - inak by sa nedal alokovat
      if (!filesTree.getRootFileInfo().isMine() && fileInfo.getType()!=FileInfo.PROJECT_ROOT)
      {
         //JOptionPane.showMessageDialog(this, "You must allocate project first.", "Error", JOptionPane.ERROR_MESSAGE);
         //return;
      }

      int ret=0;
      //allocate file
      if (fileInfo.getType()==FileInfo.FILE)
      {
         fileInfo.setOwner(project.getMyName());
         filesTree.setCurrentNode(fileInfo);
         //menuFileSaveProject_actionPerformed(null);
         //TODO: send message to server
      }
      //allocate project file
      else if (fileInfo.getType()==FileInfo.PROJECT_ROOT)
      {
         /*if (client.allocFile(fileInfo.getFilePath()+"/"+fileInfo.getFileName())==1)
         {
            //download project
            fileInfo=filesTree.getRootFileInfo();
            ret=client.getFile(fileInfo.getFilePath()+"/"+fileInfo.getFileName());
            if (ret==1)
            {

               reOpenProject(this.internalToSystemPathSeparator(project.getLocalPath()+"/"+fileInfo.getFileName()));

               fileInfo=filesTree.getRootFileInfo();
               setStatusBar("Project allocated.");
               fileInfo.setOwner(project.getMyName());
               filesTree.setCurrentNode(fileInfo);
            }
            else setStatusBar("Project is already allocated by othe user.");
         }
         else setStatusBar("Project is already allocated by othe user.");*/
      }
      //allocate element
      else if (fileInfo.getType()==FileInfo.SUB_FILE)
      {
         if (client.allocElement(fileInfo.getFilePath()+"/"+fileInfo.getFileName(), fileInfo.getElementName())==1)
         {
            //ret=client.getElement(fileInfo.getFilePath()+"/"+fileInfo.getFileName(), fileInfo.getElementName());
            //fileInfo.setOwner(project.getMyName());

            ElementParser parser = new ElementParser();
            parser.readFile( project.getLocalPath() + File.separatorChar + fileInfo.getPathWithFile());
            parser.allocElement(fileInfo.getElementName(), myFullName);

            //filesTree.setCurrentNode(fileInfo);
            //menuFileSaveProject_actionPerformed(null);
            //TODO: send message to server
         }
         else
         {
            setStatusBar("Can't allocate element.");
         }
      }
      filesTree.repaint();
   }

   //unallocate entity
   void treeUnAllocate_actionPerformed(ActionEvent e)
   {
      if (!client.isConnected())
      {
         JOptionPane.showMessageDialog(this, "You are not connected to server.", "Error", JOptionPane.ERROR_MESSAGE);
         return;
      }

      if (!filesTree.getRootFileInfo().isMine())
      {
         //JOptionPane.showMessageDialog(this, "You must allocate project first.", "Error", JOptionPane.ERROR_MESSAGE);
         //return;
      }

      FileInfo fileInfo=filesTree.getSelectedFileInfo();

      int ret=0;
      if (fileInfo.getType()==FileInfo.FILE)
      {
         fileInfo.setOwner("");
         filesTree.setCurrentNode(fileInfo);
         menuFileSaveProject_actionPerformed(null);
      }
      else if (fileInfo.getType()==FileInfo.PROJECT_ROOT)
      {
         /*if (client.unAllocFile(fileInfo.getFilePath()+"/"+fileInfo.getFileName())==1)
         {
            if (projectFileName==null || !projectFileName.exists())
            {
               JOptionPane.showMessageDialog(this, "You must first save the project localy.", "Error", JOptionPane.ERROR_MESSAGE);
               return;
            }
            //menuFileSaveProject_actionPerformed(null);
            //ret=client.putFileAs(fileInfo.getFilePath()+"/"+projectFileName.getName(), project.getProjectName()+".shp");
            //if (ret==1)
            //{
               setStatusBar("Project unallocated.");
               fileInfo.setOwner("");
               filesTree.setCurrentNode(fileInfo);
               menuFileSaveProject_actionPerformed(null);
               client.putFileAs(fileInfo.getFilePath()+"/"+projectFileName.getName(), project.getProjectName()+".shp");
               //TODO: test ci bol na server skutocne uploadnuty...
            //}
            //else setStatusBar("Can't upload project to server.");
         }
         else setStatusBar("Project is already unallocated by othe user (why?).");
         */
      }
      else if (fileInfo.getType()==FileInfo.SUB_FILE)
      {
         if (client.unAllocElement(fileInfo.getFilePath()+"/"+fileInfo.getFileName(), fileInfo.getElementName())==1)
         {
            //ret=client.getElement(fileInfo.getFilePath()+"/"+fileInfo.getFileName(), fileInfo.getElementName());
            if (fileInfo.getFileName().toLowerCase().endsWith(".java"))
            {
               ElementParser parser = new ElementParser();
               parser.readFile( project.getLocalPath() + File.separatorChar + fileInfo.getPathWithFile());
               parser.unAllocElement(fileInfo.getElementName());
               fileInfo.setOwner("");
               filesTree.setCurrentNode(fileInfo);
               //menuFileSaveProject_actionPerformed(null);
            }
         }
         else
         {
            setStatusBar("Can't unallocate element.");
         }
      }
      filesTree.repaint();
   }

   //download project file from server
   void b_dwn_project_actionPerformed(ActionEvent e)
   {
      JFileChooser fc = new JFileChooser();
      fc.setDialogTitle("Select local path for project");
      fc.setMultiSelectionEnabled(false);
      fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
      int returnVal = fc.showOpenDialog(this);

      if (returnVal == JFileChooser.APPROVE_OPTION)
      {
         try
         {
            System.out.println("Getting file");

            //download
            setStatusBar("Getting project information.");
            project.setLocalPath(fc.getSelectedFile().getAbsolutePath());
            client.send("/set_project#"+(String)c_projects.getSelectedItem());


            //client.getFile((String)c_projects.getSelectedItem()+".shp");
            client.send("/list_files_in_project#"+(String)c_projects.getSelectedItem());

            //open
            //openProject(new File(fc.getSelectedFile().getAbsolutePath()+File.separatorChar+(String)c_projects.getSelectedItem()+".shp"));

            //modify
            //project.setLocalPath(fc.getSelectedFile().getAbsolutePath());
            //project.setMyName(name_txt.getText());

            //save
            //menuFileSaveProject_actionPerformed(null);

            //wait for get all file list
            client.waitForEnd(Listen.RET_FILE_LIST);

            project.setLocalPath(fc.getSelectedFile().getAbsolutePath());
            project.setProjectName((String)c_projects.getSelectedItem());
            project.setProjectTree(filesTree.storeToVector());
            project.setMyName(myFullName);

            //download files in project from server
            int result = JOptionPane.showConfirmDialog(this,"Do you want to download files in project from server?","Download",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE);
            if (result == JOptionPane.YES_OPTION) menuProjectDownloadFromServer_actionPerformed(null);

            setStatusBar("Project download complete.");

         }
         catch (Exception ex)
         {
            setStatusBar("Error: can't download project file "+ex.getMessage());
         }
      }
   }


   public FilesTree getFilesTree()
   {
      return(filesTree);
   }

   public ProjectInfo getProjectInfo()
   {
      return(project);
   }

   public static String internalToSystemPathSeparator(String fromPath)
   {
      char pathSep = File.separatorChar;
      String toPath=fromPath.replace('/', pathSep);
      return(toPath);
   }

   //this parse already existing file for elements
   //add elements to the tree
   //create elements on server
   public void parseFileForElements()
   {
      parseFileForElements(filesTree.getSelectedFileInfo());
   }

   public void parseFileForElements(FileInfo fileInfo)
   {

      String fileName=project.getLocalPath()+"/"+fileInfo.getFilePath()+"/"+fileInfo.getFileName();
      ElementParser parser=new ElementParser();
      Vector elementNames=parser.parseByMethodName(fileName);

      if (fileInfo==null)
      {
         //TODO: write some errors
         return;
      }

      int i;

      for (i=0; i<elementNames.size(); i++)
      {
         FileInfo subFileInfo=new FileInfo(fileInfo.getPathWithFile(), FileInfo.SUB_FILE, FileInfo.ALLOCATED_BY_ME);
         subFileInfo.setElementName((String)elementNames.elementAt(i));
         filesTree.addObject(subFileInfo);

         //client.createNewElement(fileInfo.getPathWithFile(), (String)elementNames.elementAt(i), "");
      }

      String names=filesTree.getElementNames();

      System.out.println("NAMES="+names);
      if (names!=null)
      {
         setStatusBar("This file doesn't contains elements.");
         return;
      }
      if (client.updateElements(fileInfo.getPathWithFile(), names)!=1)
      {
         setStatusBar("Can't write element's to server.");
      }
   }

   //set text in status bar & refresh window
   public void setStatusBar(String text)
   {
      statusBar.setText(text);
      this.paint(this.getGraphics());
   }

   void b_test_mouseClicked(MouseEvent e)
   {
      //clearProject("test");
      //filesTree.test();
      client.send("/list_files_in_project#final-test");
   }

   public void setMyFullName(String name)
   {
      this.myFullName = name;
      project.setMyName(myFullName);
      System.out.println("My Full Name="+this.myFullName);
   }

}

class f_main_treeProperties_actionAdapter implements java.awt.event.ActionListener
{
   f_main adaptee;

   f_main_treeProperties_actionAdapter(f_main adaptee)
   {
      this.adaptee = adaptee;
   }

   public void actionPerformed(ActionEvent e)
   {
      adaptee.treeProperties_actionPerformed(e);
   }
}

class f_main_treeRemove_actionAdapter implements java.awt.event.ActionListener
{
   f_main adaptee;

   f_main_treeRemove_actionAdapter(f_main adaptee)
   {
      this.adaptee = adaptee;
   }

   public void actionPerformed(ActionEvent e)
   {
      adaptee.treeRemove_actionPerformed(e);
   }
}