/*
 * Client.java - server thread which comunicate with client
 * Copyright (C) 1999-2000 Lubos Balat
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package sk.jeeff.shed.server;

import java.awt.*;
import java.net.*;
import java.io.*;
import java.util.*;

import java.sql.*;


import sk.jeeff.shed.parser.*;
import sk.jeeff.shed.ShedTools;

public class Client extends Thread
{
   int ID;
   Socket socket;
   Socket dsocket;
   private String userName;
   private String password;
   private String fullName;
   private int userId;
   String forwho;   //pre koho sa bude posielat
   BufferedReader br;

   OutputStream os;
   BufferedOutputStream bos;
   BufferedInputStream bis;

   PrintWriter ps;

   int pom1,pom2;

   int DEBUG=1;
   public static final int BUFFSIZE=8192;
   char PathSep = File.separatorChar;

   public static final String ELEMENT_FILE_POSTFIX=".ELEMENT.";

   private String actualProjectName="";
   private int actualProjectId=-1;

   //konekt na databazu
   Connection dbcon;

   //send message msg to client
   public void send (StringBuffer msg)
   {
       /*try {
           bos.writeChars(msg.toString()+"\n");
           bos.flush();
       } catch (IOException e) {err("Can't write to client..");}*/
       ps.println(msg);
       //ps.flush();
   }

   public void send (String msg)
   {
       /*try {
           bos.writeChars(msg+"\n");
           bos.flush();
       } catch (IOException e) {err("Can't write to client..");}*/
       ps.println(msg);
       //ps.flush();
   }

   //constructor
   //s=command socket
   //ds=data socket
   //i=client id
   public Client(Socket s, Socket ds, int i)
   {
      ID = i;
      socket = s;
      dsocket = ds;

      try
      {
         Class.forName("org.gjt.mm.mysql.Driver").newInstance();
      }
      catch (Exception ex)
      {
         System.err.println("Nemozem zaviest JDBC: " + ex.getMessage());
      }

      try
      {
         System.err.println("SKUSAM OTVORIT SPOJENIE NA SQL");
         dbcon = java.sql.DriverManager.getConnection("jdbc:mysql://localhost/shed?user=root&password=");
         if (dbcon==null)
         {
             System.err.println("Nie je spojenie na databazu");
             return;
         }

          br = new BufferedReader(new InputStreamReader(s.getInputStream()));
          System.out.println("Get client's name");
          userName = br.readLine();
          System.out.println("Client: name=" + userName + " ID=" + i);
          password = br.readLine();
          os=s.getOutputStream();
          bos=new BufferedOutputStream(ds.getOutputStream(),BUFFSIZE);
          bis=new BufferedInputStream(ds.getInputStream(),BUFFSIZE);
          ps = new PrintWriter(os,true);
      } catch (Exception e) {
          System.out.println("Error: " + e);
      }
   }

   public String getUserName()
   {
      return(userName);
   }

   public boolean checkPassword()
   {
      try
      {
         Statement stat = dbcon.createStatement();
         ResultSet rs = stat.executeQuery("SELECT user_id, fullname FROM users WHERE login='"+userName+"' AND password='"+password+"'");
         if (rs.next())
         {
            userId = rs.getInt(1);
            fullName = rs.getString(2);
            send("/your_full_name#"+fullName);
            ps.flush();
            rs.close();
            stat.close();
            return(true);
         }
         rs.close();
         stat.close();
      }
      catch (Exception ex)
      {

      }
      return(false);
   }

   //main loop, reads command from command stream
   public void run ()
   {
      String line = null;
      String keyword;
      while (true)
      {
         try
         {
            line = br.readLine();
         } catch (IOException e)
         {
            System.out.println("Error: " + e);
            shedServer.disconnect(ID, "GENERAL ERROR");
            shedServer.notifyRoom();
            return;
         }
         /* client is gone */
         if (line == null)
         {
            shedServer.disconnect(ID, "");
            shedServer.notifyRoom();
            return;
         }
         StringTokenizer st = new StringTokenizer(line, "#");
         System.out.println("line=" + line);

         //try to get keyword
         if (st.hasMoreTokens()) keyword = st.nextToken();
         else keyword="";

         System.out.println("Server Keyword:" + keyword);

         if (keyword.equals("/msg_all"))
         {
            shedServer.sendClients("/msg#"+userName+st.nextToken("\0"));
            //st.nextToken("\0") is #message, so you don't need add # before message
         }
         else if (keyword.equals("/msg"))
         {
            try
            {
               int id=Integer.valueOf(st.nextToken()).intValue();
               shedServer.sendClient("/msg#"+userName+st.nextToken("\0"), id);
            }
            catch (Exception e)
            {
               System.out.println("Error: wrong user id in /msg");
            }
         }
         else if (keyword.equals("/set_project"))
         {
            actualProjectName=st.nextToken("\0").substring(1);
            //File project_dir = new File(shedServer.PROJECTS_DIR+PathSep+actualProjectName);
            //project_dir.mkdirs();
            //ziskaj z mena projektu jeho id
            actualProjectId=getProjectId(actualProjectName);
            System.out.println("Setting project: "+actualProjectName+" ID="+actualProjectId);
         }
         else if (keyword.equals("/get_file"))
         {
            kwGetFile(st);
         } else if (keyword.equals("/fopen"))
         {
            kwFopen(st);
         }
         else if (keyword.equals("/get_element"))
         {
            kwGetElement(st);
         }
         else if (keyword.equals("/put_element"))
         {
            kwPutElement(st);
         }
         else if (keyword.equals("/alloc_element"))
         {
            String file = st.nextToken();
            String element = st.nextToken();
            int elementId = getElementId(file, element);
            if (shedServer.allocElement(elementId, userId, dbcon) == true) send("/RET:alloc_element#OK");
            else send("/RET:alloc_element#FAIL");
            ps.flush();
            //send info for all clients
            listFilesInProject(actualProjectName, null, null, null, ""+elementId, false, true);
            //kwAllocFile(st);
         }
         else if (keyword.equals("/unalloc_element"))
         {
            String file = st.nextToken();
            String element = st.nextToken();
            int elementId = getElementId(file, element);
            if (shedServer.unAllocElement(elementId, userId, dbcon) == true) send("/RET:unalloc_element#OK");
            else send("/RET:unalloc_element#FAIL");
            listFilesInProject(actualProjectName, null, null, null, ""+elementId, false, true);
            //kwUnAllocFile(st);
         }
         else if (keyword.equals("/listprojects"))
         {
            kwListProjects();
         }
         else if (keyword.equals("/new_file"))
         {
            //kwNewFile(st);
         }
         else if (keyword.equals("/new_element"))
         {
            kwNewElement(st);
         }
         else if (keyword.equals("/update_element_names"))
         {
            kwUpdateElementNames(st);
         }
         else if (keyword.equals("/list_files_in_project"))
         {
            //nextToken is project name
            kwListFilesInProject(st.nextToken());
         }
         else if (keyword.equals("/get_user_list"))
         {
            kwGetUserList();
            //send("/user_list#jeeff#janko#ferko#ferko1#ferko2#ferko3#ferko4#ferko5#ferko6#ferko7#ferko8#ferko9#ferko10#ferko11#ferko12#ferko13");
         }
         else if (keyword.equals("QUIT"))
         {
            shedServer.disconnect(ID, "Disconnected");
            shedServer.notifyRoom();
            this.stop();
         }
         else if (keyword.equals("/new_project"))
         {
            if (shedServer.newProject(st, dbcon)==true) send("/RET:new_project#OK");
            else send("/RET:new_project#FAIL");
         }
      }
   }

   String projectFiles;
   //recursyvely add files in directory to string, separate by :
   /*void add_files(File f, int cut)
   {
      File current_dir = new File(f, ".");
      String file_list[] = current_dir.list();
       String pomStr;
       StringTokenizer fileTok;

      for (int i = 0; i < file_list.length; i++)
      {
         File current_file = new File(f, file_list[i]);

         if (current_file.isDirectory()) add_files(current_file,cut);
         else
         {
            //flist.addItem(current_file.getAbsolutePath());
            fileTok = new StringTokenizer(current_file.getAbsolutePath().substring(cut), PathSep+"");
            pomStr= "";
            while (fileTok.hasMoreTokens()) pomStr=pomStr+"/"+fileTok.nextToken();
            projectFiles=projectFiles+":"+pomStr.substring(1);
         }
      }
   } */


   //creates absolute directory path for given filename
   //ALWAYS ends with / (path separator char)
   private String getAbsoluteDirectoryPath(String filename)
   {
      String directory;
      StringTokenizer sd=new StringTokenizer(filename, "/");

      directory=shedServer.PROJECTS_DIR + PathSep + actualProjectName + PathSep;
      pom2=sd.countTokens();

      for (pom1=1; pom1<=pom2-1; pom1++)
      {
         directory = directory + sd.nextToken() + PathSep;
      }
      return(directory);
   }

   //creates directory path for given filename
   //ALWAYS ends with / (path separator char)
   private String getDirectoryPath(String filename)
   {
      String directory;
      StringTokenizer sd=new StringTokenizer(filename, "/");

      directory="/";
      pom2=sd.countTokens();

      for (pom1=1; pom1<=pom2-1; pom1++)
      {
         directory = directory + sd.nextToken() + "/";
      }
      return(directory);
   }

   //get only filename from path in string filename
   private String getFileName(String filename)
   {
      int index=filename.lastIndexOf('/');
      if (index==-1) return (filename);
      else
      {
         if (filename.length()>index) return(filename.substring(index+1));
         else return ("");
      }
   }

/* ------------------------------------------------------------------------*/
/* --------------------------------- KEYWORDS ---------------------------- */

   private void kwGetUserList()
   {
      //posli mu zoznam userov vo formate user_name#user_id#user_name#user_id...
      String list="/user_list";
      try
      {
         Statement stat = dbcon.createStatement();
         ResultSet rs = stat.executeQuery("SELECT fullname, user_id FROM users");
         while (rs.next())
         {
            list = list + "#" + rs.getString(1) + "#" + rs.getString(2);
         }
      }
      catch (Exception ex)
      {
         list = list+"#";
      }
      send(list);
   }

   private void kwListProjects()
   {
      String projects="/RET:listprojects";
      try
      {
         Statement stat = dbcon.createStatement();
         ResultSet rs = stat.executeQuery("SELECT p.project_name FROM projects p, users_projects u WHERE p.project_id = u.project_id AND u.user_id = "+userId+" order by project_name");
         while (rs.next())
         {
            projects=projects+"#"+rs.getString(1);
         }
      }
      catch (Exception ex)
      {
         projects = projects+"#";
      }
      send(projects);
   }

   private void kwGetElement(StringTokenizer st)
   {
      String origFilename=st.nextToken();
      String elementname=st.nextToken();

      String directory=getDirectoryPath(origFilename);
      String filename=getFileName(origFilename);

      try
      {
         Statement stat = dbcon.createStatement();
         String seqel = "select e.code from elements e, files f, files_elements fe where f.file_name='"+filename+"' AND f.file_path='"+directory+"' AND e.element_name='"+elementname+"' AND fe.file_id=f.file_id AND fe.element_id = e.element_id ORDER by fe.position";
         dbg(seqel);
         ResultSet rs = stat.executeQuery(seqel);

         if (rs.next())
         {
            String code = rs.getString(1);
            if (! code.endsWith("\r\n")) code = code+"\r\n";
            dbg("code="+code);
            sendStringToClient(code, "/put_element#"+filename+"#"+elementname+"#", true);
            //send("/put_element#"+filename+"#"+elementname+"#"+"1204");
         }
         else
         {
            //TODO: print error
         }
         rs.close();
      }
      catch (Exception ex)
      {
         err("kwGetElement"+ex.getMessage());
      }

   }

   private void kwGetFile(StringTokenizer st)
   {
      String origFileName;

      origFileName=st.nextToken();

      dbg("File opened: " + origFileName);

      String directory=getAbsoluteDirectoryPath(origFileName);
      String filename=getFileName(origFileName);

      StringBuffer buff = new StringBuffer();

      File f=new File(directory+filename+ELEMENT_FILE_POSTFIX);
      if (f.exists())
      {
         dbg("Creating temp file...");
         String tempFile=createStringFromElements(origFileName);
         dbg("temp file="+tempFile);
         sendStringToClient(tempFile, "/fopen#"+origFileName+"#", true);

         return;
      }

      //sendFileToClient(origFileName, "/fopen#"+origFileName+"#", true);
      //TODO: posli chybu
   }

   //create file from elements
   //return: path to new file
   private String createStringFromElements(String origFilename)
   {
      String directory=getDirectoryPath(origFilename);
      String filename=getFileName(origFilename);

      ElementParser parser=new ElementParser();
      parser.setParserType(origFilename);

      String elementStringBegin=parser.getElementStringBegin();
      //String elementStringEnd=parser.getElementStringEnd();
      String elementComment = parser.getElementComment();
      String elementOwner = parser.getElementOwner();
      //String elementAllocBegin=parser.getElementAllocBegin();
      //String elementAllocEnd=parser.getElementAllocEnd();
      //String elementCommentBegin=parser.getElementCommentBegin();
      //String elementCommentEnd=parser.getElementCommentEnd();

      StringBuffer outBuf = new StringBuffer();
      int locked_by;

      try
      {
         //read file
         dbg("Reading file with subfile definition");
         //FileInputStream is = new FileInputStream(directory+filename+ELEMENT_FILE_POSTFIX);
         //BufferedReader br = new BufferedReader(new InputStreamReader(is));
         //ziskaj to z db
         Statement st = dbcon.createStatement();

         ResultSet rs_users = st.executeQuery("SELECT user_id, login, fullname FROM users ORDER BY user_id");
         Hashtable user_list = new Hashtable(20);
         while (rs_users.next())
         {
            user_list.put(""+rs_users.getInt(1), rs_users.getString(3));
         }

         ResultSet rs = st.executeQuery("select e.code, e.element_name, e.locked_by from elements e, files f, files_elements fe where f.file_name='"+filename+"' AND f.file_path='"+directory+"' AND fe.file_id=f.file_id AND fe.element_id = e.element_id ORDER by fe.position");

         dbg("query OK");

         String elementName;
         String elementData;
         while (rs.next())
         {
            elementData = rs.getString(1);
            elementName = rs.getString(2);
            dbg("Writing element name="+elementName);
            outBuf.append(elementComment);
            outBuf.append(elementStringBegin);
            outBuf.append(elementName);
            //outBuf.append(elementCommentEnd);
            outBuf.append("\r\n");
            locked_by = rs.getInt(3);
            outBuf.append(elementComment+elementOwner);
            if (locked_by == 0) outBuf.append("nobody");
            else if (user_list.get(""+locked_by) == null ) outBuf.append("unknown");
            else outBuf.append((String)user_list.get(""+locked_by));

            outBuf.append("\r\n");
            outBuf.append(elementData);
            outBuf.append("\r\n");

            //outBuf.append(elementComment);
            //outBuf.append(elementStringEnd);
            //outBuf.append(elementAllocEnd);
            //outBuf.append("\r\n");
         }
         rs.close();
         dbg("Sending tempFilename name");

         //return path and filename to temp file
         return(outBuf.toString());
      }
      catch (Exception ex)
      {
         System.out.println("Can't create temp file from elements"+ex.getMessage());
         return("");
      }
   }

   //DEPREACED
   //create file from elements
   //return: path to new file
   private String createTempFileFromElements(String origFilename)
   {
      String directory=getDirectoryPath(origFilename);
      String filename=getFileName(origFilename);

      ElementParser parser=new ElementParser();
      parser.setParserType(origFilename);

      String elementStringBegin=parser.getElementStringBegin();
      //String elementStringEnd=parser.getElementStringEnd();
      String elementComment = parser.getElementComment();
      String elementOwner = parser.getElementOwner();
      //String elementAllocBegin=parser.getElementAllocBegin();
      //String elementAllocEnd=parser.getElementAllocEnd();
      //String elementCommentBegin=parser.getElementCommentBegin();
      //String elementCommentEnd=parser.getElementCommentEnd();

      try
      {
         //read file
         dbg("Reading file with subfile definition");
         //FileInputStream is = new FileInputStream(directory+filename+ELEMENT_FILE_POSTFIX);
         //BufferedReader br = new BufferedReader(new InputStreamReader(is));
         //ziskaj to z db
         Statement st = dbcon.createStatement();
         ResultSet rs = st.executeQuery("select e.code, e.element_name from elements e, files f, files_elements fe where f.file_name='"+filename+"' AND f.file_path='"+directory+"' AND fe.file_id=f.file_id AND fe.element_id = e.element_id ORDER by fe.position");

         dbg("query OK");

         /*String line;
         Vector lines = new Vector(10,10);
         while ((line=br.readLine())!=null)
         {
            if (line.length()>0) lines.add(line);
         }
         br.close();
         is.close();*/

         //temp file
         File tmpFile=File.createTempFile("tmp."+filename+ELEMENT_FILE_POSTFIX,"", new File(directory));

         FileOutputStream tmpOs = new FileOutputStream(tmpFile);
         BufferedWriter tmpBw = new BufferedWriter(new OutputStreamWriter(tmpOs));

         String elementName;
         String elementData;
         while (rs.next())
         {
            elementData = rs.getString(1);
            elementName = rs.getString(2);
            dbg("Writing element name="+elementName);
            tmpBw.write(elementComment);
            tmpBw.write(elementStringBegin);
            tmpBw.write(elementName);
            //tmpBw.write(elementCommentEnd);
            tmpBw.newLine();
            tmpBw.write(elementComment+elementOwner+"unknown");
            tmpBw.newLine();
            tmpBw.write(elementData);
            tmpBw.newLine();

            //tmpBw.write(elementComment);
            //tmpBw.write(elementStringEnd);
            //tmpBw.write(elementAllocEnd);
            //tmpBw.newLine();
            tmpBw.flush();

         }
         rs.close();

/*         int i;

         FileInputStream elementIs;
         BufferedReader elementBr;
         for (i=0; i<lines.size(); i++)
         {
            elementName=(String)lines.elementAt(i);
            dbg("Writing element name="+(String)lines.elementAt(i));
            tmpBw.write(elementAllocBegin);
            tmpBw.write(elementStringBegin);
            tmpBw.write(elementName);
            tmpBw.write(elementCommentEnd);
            tmpBw.newLine();

            dbg("pred fileIS path="+directory+filename+ELEMENT_FILE_POSTFIX+elementName);

            elementIs = new FileInputStream(directory+filename+ELEMENT_FILE_POSTFIX+elementName);
            elementBr = new BufferedReader(new InputStreamReader(elementIs));

            while ((line=elementBr.readLine())!=null)
            {
               tmpBw.write(line);
               tmpBw.newLine();
            }

            elementBr.close();
            elementIs.close();

            dbg("po write elementu");

            tmpBw.write(elementCommentBegin);
            tmpBw.write(elementStringEnd);
            tmpBw.write(elementAllocEnd);
            tmpBw.newLine();
            tmpBw.flush();

         }*/

         tmpBw.close();
         tmpOs.close();

         dbg("Sending tempFilename name");

         //return path and filename to temp file
         return(origFilename.substring(0, origFilename.lastIndexOf('/'))+"/"+tmpFile.getName());
      }
      catch (Exception ex)
      {
         System.out.println("Can't create temp file from elements"+ex.getMessage());
         return("");
      }
   }

   private int sendStringToClient(String to_send, String command, boolean sendSize)
   {
      //lsb & msb byte of size
      int lsb,msb;
      //byte size[]=new byte[2];

      byte buff[] = new byte[BUFFSIZE];
      int count;
      String strSize="";
      if (sendSize)
      {
         strSize=""+to_send.length();
      }
      send(command+strSize);

      try
      {
            count = to_send.length();
            while (count > 0)
            {
               if (to_send.length() > BUFFSIZE)
               {
                  buff = to_send.substring(0, BUFFSIZE-1).getBytes("Cp1250");
                  to_send = to_send.substring(BUFFSIZE-1);
               }
               else
               {
                  buff = to_send.getBytes("Cp1250");
                  to_send = "";
               }

               System.out.println("count="+count);
               msb= (count/256);
               lsb= (count - (msb*256));
               System.out.println("msb="+msb+" lsb="+lsb);


               dbg("Sending " + count + " bytes");

               bos.write(msb+5);
               bos.write(lsb);

               bos.write(buff,0,count);
               bos.flush();

               //wait for client OK
               //dbg(br.readLine());
               dbg("Waiting:");
               dbg(""+bis.read());

               count = to_send.length();
            }
            dbg("Writing 0");
            //msb
            bos.write(0+5);
            //lsb
            bos.write(0);
            bos.flush();

            //wait for client OK
            //dbg(br.readLine());
            dbg("Waiting: "+bis.read());

         } catch (Exception snde)
         {
            System.out.println("Unknown client ID:" + snde);
         }

      return(1);
   }

   private int sendFileToClient(String origFileName, String command, boolean sendSize)
   {
      String filename;
      File file;
      //lsb & msb byte of size
      int lsb,msb;
      //byte size[]=new byte[2];

      byte buff[] = new byte[BUFFSIZE-10];
      int count;
      FileInputStream is;
      DataInputStream ds;

      StringTokenizer sd = new StringTokenizer(origFileName, "/");

      //filename="." + PathSep;
      filename=shedServer.PROJECTS_DIR + PathSep + actualProjectName + PathSep;
      pom2=sd.countTokens();
      for (pom1=1; pom1<pom2; pom1++)
      {
         filename=filename + sd.nextToken() + PathSep;
      }
      filename = filename + sd.nextToken();
      file = new File(filename);

      System.out.println("filename="+filename+" PATH="+file.getAbsolutePath());

      try
      {
         is = new FileInputStream(filename);
         ds = new DataInputStream(is);
      }
      catch (FileNotFoundException ex)
      {
         System.out.println("Error: file "+filename+" does not exist. "+ex.getMessage());
         return(0);
      }

      String strSize="";
      if (sendSize)
      {
         strSize=""+file.length();
      }
      send(command+strSize);

      try
      {


            while ((count = ds.read(buff)) != -1)
            {
               System.out.println("count="+count);
               msb= (count/256);
               lsb= (count - (msb*256));
               System.out.println("msb="+msb+" lsb="+lsb);


               dbg("Sending " + count + " bytes");

               bos.write(msb+5);
               bos.write(lsb);

               bos.write(buff,0,count);
               bos.flush();

               //wait for client OK
               //dbg(br.readLine());
               dbg("Waiting:");
               dbg(""+bis.read());
            }
            dbg("Writing 0");
            //msb
            bos.write(0+5);
            //lsb
            bos.write(0);
            bos.flush();
            dbg("Closing ds");
            ds.close();
            is.close();

            //wait for client OK
            //dbg(br.readLine());
            dbg("Waiting: "+bis.read());

         } catch (Exception snde)
         {
            System.out.println("Unknown client ID:" + snde);
         }

      return(1);
   }

   //client sends file to server
   public void kwFopen(StringTokenizer st)
   {
      String filename;
      String directory;
      OutputStream os;
      DataOutputStream ods;

      try
      {
         String fileSize;

         StringTokenizer sd = new StringTokenizer(st.nextToken(), "/");
         fileSize=st.nextToken();

         //project=client.gui.getProjectInfo();

         //System.out.println("Project main dir:"+project.getLocalPath());

         //directory=project.getLocalPath() + PathSep;
         directory=shedServer.PROJECTS_DIR + PathSep + actualProjectName + PathSep;
         pom2=sd.countTokens();

         for (pom1=1; pom1<=pom2-1; pom1++)
         {
            directory = directory + sd.nextToken() + PathSep;
         }

         //directory = directory + sd.nextToken();

         filename=sd.nextToken();

         System.out.println("Writing file="+filename+" to dir="+directory);

         File dir = new File(directory);
         //File file = new File(directory + filename);
         System.out.println("Creating dir: " + dir.mkdirs());

         //output stream to write file
         os = new FileOutputStream(directory + PathSep + filename);
         ods = new DataOutputStream(os);

         //TODO: osetrit nespravne poslanie
         //writeDataFromStream(ods);
//TODO: nahradit

         try
         {
            ods.flush();
            os.flush();
            ods.close();
            os.close();
            //bis.close();
            //br = new BufferedReader(new InputStreamReader(is),4096);
            dbg("File closed");
            //client.gui.statusBar.setText("Download successfull");
         } catch (IOException ex) {System.out.println("Can't close file...");}

      } catch (IOException ex)
      {
         System.out.println("Can't open file...");
      }
      // client.notifyAll();
      //Client.chat_txt.appendText(st.nextToken("\0") + "\n");

   }

   public void kwPutElement(StringTokenizer st)
   {
      String filename;
      String directory;

      try
      {
         String fileSize;
         String origFileName=st.nextToken();
         String elementName=st.nextToken();

         fileSize=st.nextToken();

         //TODO: osetrit nespravne poslanie
         String elementData = new String(getDataFromStream().getBytes(), "Cp1250");

         System.out.println("ELEMNT DATA="+elementData);

         int elementId = getElementId(origFileName, elementName);

         System.out.println("E ID="+elementId);

         long now = (new java.util.Date()).getTime();

         String query="";
         if (elementId != -1)
         {
            query = "UPDATE elements SET code='"+elementData+"', last_update="+now+" WHERE element_id="+elementId;
         }
         else
         {

         }

         System.out.println("query="+query);

         Statement stat = dbcon.createStatement();
         ResultSet rs = stat.executeQuery(query);

         //addElementToFile(directory+filename+this.ELEMENT_FILE_POSTFIX, elementName, "");

         dbg("File closed");

      } catch (Exception ex)
      {
         System.out.println("Can't put element: " + ex.getMessage());
      }
      // client.notifyAll();
      //Client.chat_txt.appendText(st.nextToken("\0") + "\n");

   }

   //write data from data stream to data output stream ods
   private String getDataFromStream() throws IOException
   {
      byte buff[] = new byte[BUFFSIZE+10];
      int lsb, msb;
      //byte size[]=new byte[2];
      long fileLengthCount;
         int count;
         dbg("COUNT");

         fileLengthCount=0;

         msb=bis.read()-5;
         lsb=bis.read();
         count=msb*256+lsb;
         StringBuffer strBuf = new StringBuffer(count);
         System.out.println("msb="+msb+" lsb=" + lsb + " total=" + ((msb*256)+lsb) + " count="+count);
         int pos = 0;
         while (count !=0)
         {
            int value;
            for (int pom1=0;pom1<count;pom1++)
            {
               value=bis.read();
               if (value==-1) System.out.println("---VALUE="+value);
               buff[pom1]=(byte)value;
               System.out.print(""+buff[pom1]+(char)buff[pom1]);
               strBuf.append((char)buff[pom1]);
            }
            dbg("Writing " + count + " bytes");
            //ods.write(buff,0,count);

            fileLengthCount+=count;

            //ps.println("GETFILE OK");
            //ps.flush();
            bos.write(0);
            bos.flush();

            //.gui.statusBar.setText("Downloading "+filename+" "+fileLengthCount+"/"+fileSize);

            msb=bis.read()-5;
            lsb=bis.read();
            count=msb*256+lsb;
            System.out.println("msb="+msb+" lsb=" + lsb + " total=" + ((msb*256)+lsb) + " count="+count);
         }
         dbg("Writing ended");

         //ps.println("GETFILE OK");
         //ps.flush();
         bos.write(0);
         bos.flush();
      return(strBuf.toString());
   }

   /*public void kwNewFile(StringTokenizer st)
   {
      String origFilename=st.nextToken();
      String directory=getAbsoluteDirectoryPath(origFilename);
      String filename=getFileName(origFilename);
      try
      {
         System.out.println("Creating new file in:"+directory+filename);
         File f = new File(directory);
         f.mkdirs();
         f = new File(directory+filename);
         f.createNewFile();
         //f.setReadOnly();
         send("/new_file#"+origFilename);
      }
      catch (Exception ex)
      {
         System.out.println("Can't create file: "+filename);
         send("/RET:new_file#NO");
         //TODO: send error to client
      }

   } */

   public void kwNewElement(StringTokenizer st)
   {
      String origFilename=st.nextToken();
      String elementName = st.nextToken();
      String afterElementName="";
      if (st.hasMoreTokens()) afterElementName = st.nextToken();

      String path = getDirectoryPath(origFilename);
      String file = getFileName(origFilename);

      //String directory=getAbsoluteDirectoryPath(origFilename);
      //String filename=getFileName(origFilename);
      try
      {
         //File f = new File(directory+filename+this.ELEMENT_FILE_POSTFIX);
         //if (!f.exists()) f.createNewFile();
         //addElementToFile(directory+filename+this.ELEMENT_FILE_POSTFIX, elementName, afterElementName);
         //f = new File(directory+filename+this.ELEMENT_FILE_POSTFIX+elementName);
         //f.createNewFile();
         //f.setReadOnly();

         Statement stat = dbcon.createStatement();
         String seqel;
         java.util.Date now = new java.util.Date();
         long i_now = (long) (now.getTime() / 1000);
         //get file_id for specified name
         int file_id = getFileId(origFilename);

         if (file_id == -1)
         {
            //create new file
            seqel = "INSERT INTO files (file_name, file_path, file_type, file_created_by, file_create_date) ";
            //TODO: get right file type
            seqel = seqel + "VALUES ('"+file+"', '"+path+"', 1, "+userId+", "+i_now+")";
            stat.execute(seqel);
            //get file id
            ResultSet rs_fid = stat.executeQuery("SELECT LAST_INSERT_ID();");
            if (rs_fid.next())
            {
               file_id = rs_fid.getInt(1);
               stat.execute("INSERT INTO project_files VALUES ("+actualProjectId+", "+file_id+")");
            }
         }

         //insert new element into DB
         seqel = "INSERT INTO elements (element_name, element_created_by, element_create_date, locked_by, locked_date, code, last_update) ";
         seqel = seqel +"VALUES ('"+elementName+"', "+userId+", "+i_now+", "+userId+", "+i_now+", '', "+i_now+")";
         stat.executeQuery(seqel);

         //add element id to element list
         //get element_id
         ResultSet rs = stat.executeQuery("SELECT LAST_INSERT_ID();");
         if (rs.next())
         {
            int element_id = rs.getInt(1);
            rs.close();
            //if after element name is set, insert element after that
            int new_pos = 0;
            if (afterElementName.length() > 0)
            {
               int afterElementId = getElementId(origFilename, afterElementName);
               rs = stat.executeQuery("SELECT position FROM files_elements WHERE file_id="+file_id+" AND element_id="+afterElementId);
               rs.next();
               int afterElementPos = rs.getInt(1);
               //increase position on next elements
               stat.execute("UPDATE files_elements SET position=position+1 WHERE file_id="+file_id+" AND position > "+afterElementPos);
               new_pos = afterElementPos + 1;
            }
            else
            {
               //rs = stat.executeQuery("SELECT max(position) FROM files_elements WHERE file_id="+file_id);
               //rs.next();
               //put element before all elements
               stat.execute("UPDATE files_elements SET position=position+1 WHERE file_id="+file_id);
               new_pos = 1;
            }
            stat.execute("INSERT INTO files_elements VALUES ("+file_id+", "+element_id+", "+new_pos+")");
            send("/new_element#"+origFilename+"#"+elementName+"#"+afterElementName);
            //listFilesInProject(actualProjectName);

         }

         //TODO: send error to client
      }
      catch (Exception ex)
      {
         System.out.println("Can't create element: "+ex.getMessage());
         //TODO: send error to client
      }

   }

   public void kwUpdateElementNames(StringTokenizer st)
   {
      String origFilename=st.nextToken();
      String elementName;
      String directory=getAbsoluteDirectoryPath(origFilename);
      String filename=getFileName(origFilename);
      try
      {
         File f = new File(directory+filename+this.ELEMENT_FILE_POSTFIX);
         if (!f.exists()) f.createNewFile();

         FileOutputStream os = new FileOutputStream(directory+filename+this.ELEMENT_FILE_POSTFIX);
         BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(os));

         while (st.hasMoreTokens())
         {
            elementName=st.nextToken();

            bw.write(elementName);
            bw.newLine();

            f = new File(directory+filename+this.ELEMENT_FILE_POSTFIX+elementName);
            f.createNewFile();
         }

         bw.close();
         os.close();

         send("/RET:update_element_names#OK");
      }
      catch (Exception ex)
      {
         System.out.println("Can't update element names in file: "+filename);
         send("/RET:update_element_names#NO");
         //TODO: send error to client
      }

   }

   //add elementName to file with declaration of elements after element afterElementName
   /*private int addElementToFile2(String fileName, String elementName, String afterElementName) throws IOException
   {
      File f = new File (fileName);
      if (!f.exists()) f.createNewFile();

      FileInputStream is = new FileInputStream(fileName);
      BufferedReader br = new BufferedReader(new InputStreamReader(is));
      String line;
      Vector lines = new Vector(10,10);
      System.out.println("client.New element: Reading file:"+fileName);
      boolean elementAllreadyExists=false;
      while ((line=br.readLine())!=null)
      {
         lines.add(line);
         if (line.trim().equalsIgnoreCase(elementName))
         {
            elementAllreadyExists = true;
            break;
         }
      }
      System.out.println("client.New element: File readed. lines:"+lines.size());
      br.close();
      is.close();

      if (elementAllreadyExists)
      {
         System.out.println("Element "+elementName+" allready exists...");
         return(1);
      }

      FileOutputStream os = new FileOutputStream(fileName);
      BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(os));
      int i;
      for (i=0; i<lines.size(); i++)
      {
         line=(String)lines.elementAt(i);
         if (afterElementName.length()>0 && line.equals(afterElementName))
         {
            bw.write(line);
            bw.newLine();
            bw.write(elementName);
            bw.newLine();
         }
         else
         {
            bw.write(line);
            bw.newLine();
         }
      }
      if (afterElementName.length()<1)
      {
         bw.write(elementName);
         bw.newLine();
      }
      bw.close();
      os.close();
      return(1);
   } */

   private int getElementId(String fileName, String elementName)
   {
      String path = getDirectoryPath(fileName);
      String file = getFileName(fileName);
      try
      {
         Statement st = dbcon.createStatement();
         System.out.println("SELECT e.element_id FROM elements e, files f, files_elements fe WHERE f.file_id = fe.file_id AND e.element_id = fe.element_id AND f.file_name='"+file+"' AND f.file_path='"+path+"' AND e.element_name='"+elementName+"'");
         ResultSet rs = st.executeQuery("SELECT e.element_id FROM elements e, files f, files_elements fe WHERE f.file_id = fe.file_id AND e.element_id = fe.element_id AND f.file_name='"+file+"' AND f.file_path='"+path+"' AND e.element_name='"+elementName+"'");
         if (rs.next())
         {
            return(rs.getInt(1));
         }
      }
      catch(Exception ex)
      {

      }
      return(-1);
   }

   private int getFileId(String fileName)
   {
      String path = getDirectoryPath(fileName);
      String file = getFileName(fileName);
      try
      {
         Statement st = dbcon.createStatement();
         ResultSet rs = st.executeQuery("SELECT file_id FROM files WHERE file_name='"+file+"' AND file_path='"+path+"'");
         if (rs.next())
         {
            return(rs.getInt(1));
         }
      }
      catch(Exception ex)
      {

      }
      return(-1);
   }

   public int getProjectId(String projectName)
   {
      int ret=-1;
      try
      {
         Statement st = dbcon.createStatement();
         ResultSet rs = st.executeQuery("select project_id from projects where project_name='"+projectName+"'");
         if (rs.next())
         {
            ret=rs.getInt(1);
         }
         rs.close();
         st.close();
      } catch (Exception ex) {}
      return(ret);
   }

   public void kwListFilesInProject(String projectName)
   {
      listFilesInProject(projectName);
   }

   public void listFilesInProject(String projectName)
   {
      listFilesInProject(projectName, null, null, null, null, true, false);
   }

   public void listFilesInProject(String projectName, String fileName, String filePath, String elementName, String elementId, boolean clearList, boolean sendToAllClients)
   {
      //ziskaj id projektu
      int projectId = getProjectId(projectName);
      try
      {
         String query;
         String fileQuery="";
         String pathQuery="";
         String elementQuery="";
         String elementIdQuery="";
         if (fileName != null) fileQuery = " AND f.file_name='"+fileName+"'";
         if (filePath != null) pathQuery = " AND f.file_path='"+filePath+"'";
         if (elementName != null) elementQuery = " AND e.element_name='"+elementName+"'";
         if (elementId != null) elementIdQuery = " AND e.element_id='"+elementId+"'";

         query = "SELECT f.file_path, f.file_name, f.file_type, f.file_created_by, f.file_create_date, e.element_name, e.locked_by, e.locked_date, e.element_created_by, e.element_create_date "+
                 "FROM files f, elements e, files_elements fe, projects_files pf "+
                 "WHERE fe.file_id=f.file_id AND fe.element_id=e.element_id AND pf.file_id=f.file_id AND pf.project_id="+projectId+" "+
                 fileQuery+pathQuery+elementQuery+elementIdQuery+
                 " ORDER BY pf.file_id, f.file_path, f.file_name, fe.position";
         System.out.println("LISTING FILES: query="+query);
         Statement st=dbcon.createStatement();
         ResultSet rs = st.executeQuery(query);
         if (clearList)
         {
            if (sendToAllClients) shedServer.sendClients("/clear_files_in_project#projectName");
            else send("/clear_files_in_project#projectName");
         }
         String msg;
         while (rs.next())
         {
            msg = "/file_list#"+rs.getString(1)+"#"+rs.getString(2)+"#"+rs.getString(3)+"#"+rs.getString(4)+"#"+rs.getString(5)+"#"+rs.getString(6)+"#"+rs.getString(7)+"#"+rs.getString(8)+"#"+rs.getString(9);
            System.out.println(msg);
            if (sendToAllClients) shedServer.sendClients(msg);
            else send(msg);
         }
         if (sendToAllClients) shedServer.sendClients("/RET:file_list_ok#ok");
         else send("/RET:file_list_ok#ok");
      }
      catch (Exception ex)
      {
         if (sendToAllClients) shedServer.sendClients("/RET:file_list_ok#fail");
         else send("/RET:file_list_ok#fail");
      }
   }

   /*public void kwAllocFile(StringTokenizer st)
   {
      String origFilename=st.nextToken();
      String directory=getAbsoluteDirectoryPath(origFilename);
      String filename=getFileName(origFilename);

      boolean alloc=shedServer.allocFile(directory+filename);
      System.out.println("Client ALLOC="+alloc);
      if (alloc) send("/RET:alloc_file#OK");
      else send("/RET:alloc_file#NO");
   } */

   /*public void kwUnAllocFile(StringTokenizer st)
   {
      String origFilename=st.nextToken();
      String directory=getAbsoluteDirectoryPath(origFilename);
      String filename=getFileName(origFilename);

      boolean alloc=shedServer.unAllocFile(directory+filename);
      System.out.println("Client UNALLOC="+alloc);
      if (alloc) send("/RET:unalloc_file#OK");
      else send("/RET:unalloc_file#NO");
   } */


   public void err(String text)
   {
        System.err.println(text);
   }

   public void dbg(String text)
   {
        if (DEBUG==1) System.out.println(text);
   }

}
